/*Funcin: FBIBSCB.CPP
	Proceso: Contiene el proceso para ralizar Consulta,Altas,Bajas y
					 Movimientos de la bibliografa para el programa SCB.CPP*/

void abcbib(int na)      //Nivel de acceso:0,Consulta (usuario);1,Catlogo;2,Prstamo
 {
	struct campstructs vcs[MAXR],reg;
	FILE *fpx;             //Puntero a archivo ndice solicitado (primario)
	int x,y,a,b,c;         //Coordenadas para mostrar recuadro y datos
	long cont;             //Contador de registros
	int vtcal,hztal,NC;    //Contador vtcal de reg. y hztal de opciones:referente a pantalla,nm. de carpetas con acceso
	int numpg,pginc,pgdec; //numpg:nm. de pginas, pginc:pgina actual,pgdec:pgina opuesta
	unsigned int ctalt,ctaltem; //Control de altas:normal,por tema y por adquisicin
	int rec,mas,rpg;       //Control altas:hubo altas,cuenta en arreglo,repaginar
	int brk;               //brk:salir de ciclo,auxiliar en disiciones y ubicacin de pgina en bsqueda alfabtica
	int nrcia;             //Nm. de registros que se cargaron en el arreglo
	int cia;               //Contador interno de arreglo p/mostrar registros en pantalla
	int pgcia;             //Contador de pgina interno al arreglo
	int nrb;               //Indicador si hubo baja de un registro
	int camb,lci;          //camb:0=no hay cambios,lci:largo del campo indexado
	long nrx,nrtx;         //Nm. de registros en ndices
	if((pos=leenomarch(fechoy,carp))!=-1)
	 {
		strcpy(BD,opconf.ruta);strcat(BD,fechoy);
		regs=calcregs(BD,0);nx=(carp==0) ? 5 : 4; //Nm. de registros e ndices del catlogo
		if((pos=leenomarch(fechoy,7+carp))!=-1)
		 {
			strcpy(BK,opconf.ruta);strcat(BK,fechoy);
			if(regs>0 && calcregs(BK,0)==0) BK[0]='@'; //Backup no existe y no se utilizar
			for(x=0;x<nx;x+=1) //Pone ruta y nombres de archivos ndices,excepto por adq.
			 {
				pos=(carp==0) ? leenomarch(fechoy,26+x) : leenomarch(fechoy,27+5*carp+x);
				if(pos==-1) break;strcpy(IND[x],opconf.ruta);strcat(IND[x],fechoy);
			 }
			if(pos!=-1)
			 switch(carp) //Da valor a regsxmat y regsxadq
				{
				 case 0:regsxmat=calcregs(IND[3],2);
				 case 1:
				 case 2:
				 case 3:
				 case 4:
				 case 5:if(pos!=-1) pos=leenomarch(fechoy,14+carp);
					if(pos==-1) break;strcpy(BDADQ,opconf.ruta);strcat(BDADQ,fechoy);
					regsxadq=calcregs(BDADQ,1);
					if(pos!=-1) pos=leenomarch(fechoy,20+carp);
					if(pos==-1) break;strcpy(BKADQ,opconf.ruta);strcat(BKADQ,fechoy);
					if(regsxadq>0 && calcregs(BKADQ,1)==0) BKADQ[0]='@';
					if(pos!=-1) pos=(carp==0) ? leenomarch(fechoy,31) : leenomarch(fechoy,31+5*carp);
					if(pos==-1) break;strcpy(ADQNDX,opconf.ruta);strcat(ADQNDX,fechoy);
				}
		 }
	 }
	if(pos!=-1) {
	carpx=0;nrx=regs;nrtx=(carp==0) ? regsxmat : 0;a=b=40;c=330;lci=40; //Valores por default al entrar
	setcolor(14);settextstyle(3,0,1);
	switch(carp) //Ttulo fichero
	 {
		case 0:strcpy(titcarp,"LIBROS");break;
		case 1:strcpy(titcarp,"REVISTAS");break;
		case 2:strcpy(titcarp,"PERIODICOS");break;
		case 3:strcpy(titcarp,"FOLLETOS");break;
		case 4:strcpy(titcarp,"FASCICULOS");break;
		case 5:strcpy(titcarp,"VARIOS");
	 }
	outtextxy((640-textwidth(titcarp))/2,50,titcarp);
	setcolor(7);rectangle(368,58,621,107);
	recdrocsf();outtextxy(476,67,"_"); //Subrayado de la letra C
	switch(carp)
	 {
		case 1:outtextxy(380,65,"Ao  Nm");
		case 0:
		case 4:(carp==4) ? outtextxy(440,65,"Fas") : outtextxy(440,65,"Vol");
		 if(carp==0) outtextxy(380,88,"Area de consulta:"); //Solo libro lo tiene
	 }settextstyle(0,0,0);
	if((fbd=fopen(BD,"rb+"))!=NULL)
	 {
		mensajes(405,"Abriendo base de datos...",14);
		fpx=fopen(IND[carpx],"rb+"); //Asigna ndice solicitado a puntero principal
		for(nrcia=0;nrcia<nrx && nrcia<MAXR;nrcia+=1) //Leer primeros MAXR registros del ndice
		 {
			fread(&vindex[nrcia],sizeof(vindex[nrcia]),1,fpx);
			fseek(fbd,vindex[nrcia].posicion*sizeof(vcs[nrcia]),0);
			fread(&vcs[nrcia],sizeof(vcs[nrcia]),1,fbd);
			if(!(carp==0 && carpx==3))
			 if((ftmp=fopen(IND[nx-1],"rb"))!=NULL)
				{
				 if((pos=buscax(ftmp,regs,vcs[nrcia].clasif,0))<0)
					{
					 putchar(7);
					 mensmoment(390,"! NO CORRESPONDE CATALOGO AL INDICE !",2);nrcia=-1;break;
					}
				 else
					{
					 fseek(ftmp,pos*sizeof(ndx),0);fread(&ndx,sizeof(ndx),1,ftmp);
					 if(strcmp(vcs[nrcia].clasif,ndx.atet)!=0) { putchar(7);mensmoment(390,"! NO CORRESPONDE CATALOGO AL INDICE !",2);nrcia=-1;break;}
					}fclose(ftmp);
				}
		 }//No se decrementa nrcia ya que va uno adelante
		mensajes(405,"Abriendo base de datos...",CF);
	 }
	else nrcia=0; }
	if(pos==-1) return;
	if(nrcia>=0) {
	pos=mas=rec=nrb=camb=ctalt=ctaltem=hztal=cont=vtcal=pginc=cia=pgcia=0;
	rpg=push.c=1;aux[0]='\0';
	do{
		 nomypestsup(7,11);
		 if(na==1) { abcarpinfynom(7,11);NC=11; }else { abcarpinfynom(8,8);NC=nx; }
		 if(rpg==1) //Recuenta pg. cuando hay altas o bajas o si en Cambios se quitaron o agregaron temas
			{
			 if(nrx>0) { numpg=nrx/(NRP+1);if((nrx%(NRP+1))==0) numpg-=1;	}
			 else numpg=0;
			 if(nrx>0) muestralib(0,nrcia,a,b,c,vcs); //Muestra desde el principio
			 else mensmoment(250,"! REGISTRO INDICE DE DATOS VACIO !",1);
			 rpg=0;pgdec=numpg; //Toma ltima pgina
			}
		 else if(hztal!=9) muestralib(cia-vtcal,nrcia,a,b,c,vcs);	//Muestra donde se quedo al no haber ninguna accin o imprimir
		 do{
				if((hztal>=0 && hztal<nx) || push.ch[1]==15	|| push.c==0)
				 {
					if(carp==0 && hztal==carpx) y=-1; //Si al dar <- se va a ceja por clasif, o bien, -> se va a ceja por ttulo, donde se estaba
					if(carp!=0 && (hztal==0 && carpx==0)) y=-1;
					if(hztal<nx) carpx=hztal;
					if(carp!=0) if(hztal==3 && push.ch[1]==77)	{ if(na==1) hztal=4; }
					else if((hztal==3 || hztal==4) && push.ch[1]==75) if(na==1) carpx=hztal=2;
					x=-1;
				 }
				else if(carp!=0 && na==1)	if(hztal==nx && push.ch[1]==75) if(carpx==3) y=-1;else { carpx=3;x=-1; }
				if(x==-1)
				 {
					nrx=(carp==0 && carpx==3) ? nrtx : regs; //Toma el nm. de registros segn ndice
					if(hztal<nx && nrx==0) //Para cuando no hay registros
					 { setcolor(CF);rectangle(36,116,202+(lci*8-160),131);/*outtextxy(40,122,"_");no mientras no sea color 15*/borralins(); }
					mensabc(1,10);
					if(carpx<2) { a=b=40;c=330; }else if(carpx<5) { a=c=40;b=330; }
				 }ne=80;subcarp=24;if(y==-1) push.ch[1]=15;
				switch(hztal)
				 {
					case  0:x=20;y=85;break;
					case  1:x=101;y=85;break;
					case  2:x=182;y=85;break;
					case  3:
					case  4:
					 if(carp==0)
						switch(hztal)
						 {
							case 3:x=263;y=85;break;
							case 4:x=368;y=58;ne=253;subcarp=49;
						 }
					 else { x=368;y=58;ne=253;subcarp=49; }break;
					case  5:x=134;y=420;break;
					case  6:x=215;y=420;break;
					case  7:x=296;y=420;break;
					case  8:x=377;y=420;break;
					case  9:x=458;y=420;break;
					case 10:x=539;y=420;
				 }setcolor(11);rectangle(x+1,y+1,x+ne-1,y+subcarp-1);setcolor(15);rectangle(x,y,x+ne,y+subcarp);
				if(nrx>0 && ((carp==0) ? hztal<nx : hztal<=nx) && (push.ch[1]==75 || push.ch[1]==77 || push.c==0))
				 {
					setcolor(getpixel(372,62)); //Oculta datos del recuadro sup. izq. del registro al cambiar de ndice
					for(rec=0;vcs[cia].clasif[rec]!='\0';rec+=1) (rec<15) ? csf0[rec]=vcs[cia].clasif[rec] : csf1[rec-15]=vcs[cia].clasif[rec];
					csf0[15]=csf1[rec-15]='\0';recuadrclasif(vcs[cia]);
					setcolor(CF);rectangle(36,116,202+(lci*8-160),131);//outtextxy(40,122,"_"); no mientras no sea color 15
					borralins();pos=mas=rec=nrb=camb=ctalt=ctaltem=cont=vtcal=pginc=cia=pgcia=0;
					fclose(fpx); //Cierra ndice anterior
					mensajes(405,"Abriendo archivo ndice...",14);
					fpx=fopen(IND[carpx],"rb+"); //Asigna a siguiente ndice
					for(nrcia=0;nrcia<nrx && nrcia<MAXR;nrcia+=1) //Leer primeros MAXR registros del ndice
					 {
						fread(&vindex[nrcia],sizeof(vindex[nrcia]),1,fpx);
						fseek(fbd,vindex[nrcia].posicion*sizeof(vcs[nrcia]),0);
						fread(&vcs[nrcia],sizeof(vcs[nrcia]),1,fbd);
						if(!(carp==0 && carpx==3))
						 if((ftmp=fopen(IND[nx-1],"rb"))!=NULL)
							{
							 if((pos=buscax(ftmp,regs,vcs[nrcia].clasif,0))<0)
								{ putchar(7);mensmoment(390,"! NO CORRESPONDE CATALOGO AL INDICE!",2);push.ch[1]=1;break; }
							 else
								{
								 fseek(ftmp,pos*sizeof(ndx),0);fread(&ndx,sizeof(ndx),1,ftmp);
								 if(strcmp(vcs[nrcia].clasif,ndx.atet)!=0) { putchar(7);mensmoment(390,"! NO CORRESPONDE CATALOGO AL INDICE!",2);push.ch[1]=1;break;}
								}fclose(ftmp);
							}
					 }mensajes(405,"Abriendo archivo ndice...",CF);
					if(push.ch[1]==1) break; //Salir de abcbib()
					if(nrx>0) { numpg=nrx/(NRP+1);if((nrx%(NRP+1))==0) numpg-=1; }
					else numpg=0;
					if(nrx>0) muestralib(0,nrcia,a,b,c,vcs); //Muestra desde el principio
					else mensmoment(250,"! REGISTRO INDICE DE DATOS VACIO !",1);
					mensabc(1,10);pgdec=numpg; //Toma ltima pgina
				 }
				if(nrx>0) //Mostrar
				 {
					setcolor(10);settextstyle(0,0,0);
					switch(carpx)
					 {
						case 0:outtextxy(a,142,"TITULO");break;
						case 1:outtextxy(a,142,"AUTOR");break;
						case 2:if(carp==2) outtextxy(a,142,"FECHA");else outtextxy(a,142,"EDITORIAL");break;
						case 3:
						case 4:
						 if(carp==0) (carpx==3) ? outtextxy(a,142,"MATERIA") : outtextxy(a,142,"CLASIFICACION");
						 else outtextxy(a,142,"CLASIFICACION");
					 }
					setcolor(7);vernreg_pag(cont,nrx,pginc,numpg);
					outtextxy(300,455,itoa(regsxadq,aux,10)); //prueba (tot adq.)
					setcolor(7);outtextxy(30,160+vtcal*SP,">");
					lci=(carpx==0 || (carp==0 && carpx==3)) ? 40 : (carpx==1) ? 35 : (carpx==3 || carpx==4) ? 30 : 20;
					setcolor(15);rectangle(36,116,202+(lci*8-160),131);
					if(mas==0) { setcolor(7);outtextxy(40,122,"_"); }
					setcolor((vcs[cia].existencia==vcs[cia].prestados+vcs[cia].numresrva || vcs[cia].existencia==0) ? 12 : 11); //Resalto de registro en la carpeta
					for(rec=0;vcs[cia].clasif[rec]!='\0';rec+=1) (rec<15) ? csf0[rec]=vcs[cia].clasif[rec] : csf1[rec-15]=vcs[cia].clasif[rec];
					csf0[15]=csf1[rec-15]='\0';
					opcmuestralib(cia,vtcal,a,b,c,vcs);setcolor(1);recuadrclasif(vcs[cia]);
				 }
				while(1)
				 {
					push.c=obtentecla(); //No pasa si tecla presionada no es vlida
					if(push.ch[1]!=1  && push.ch[1]!=14 && push.ch[1]!=15 && push.ch[1]!=28 && push.ch[1]!=75 &&
						 push.ch[1]!=77 && push.ch[1]!=72 && push.ch[1]!=73 && push.ch[1]!=80 && push.ch[1]!=81)
					 {
						switch(push.c) //Alt + letra subrayada
						 {
							case  5120:if(hztal!=0) { if(carpx!=0) push.c=0;hztal=0;break; }continue;
							case  7680:if(hztal!=1) { if(carpx!=1) push.c=0;hztal=1;break; }continue;
							case  8448:if(carp==2 || carp==4)	if(hztal!=2) { if(carpx!=2) push.c=0;hztal=2; }	else continue;else continue;break;
							case  4608:if(carp!=2) if(hztal!=2) { if(carpx!=2) push.c=0;hztal=2; } else continue;else continue;break;
							case 12800:if(hztal!=3 && carp==0) { if(carpx!=3) push.c=0;hztal=3;break; }continue;
							case 11776:if(hztal!=4)  { if((carpx!=4 && carp==0) || (carpx!=3 && carp!=0)) push.c=0;hztal=4;if(carp!=0) carpx=3;break; }continue;
							case  8704:if(na==1 && hztal!=5) hztal=5;else continue;push.c=0;break;
							case  4096:if(na==1 && hztal!=6) hztal=6;else continue;push.c=0;break;
							case  8192:if(na==1 && hztal!=7) hztal=7;else continue;push.c=0;break;
							case 12032:if(na==1 && hztal!=8) hztal=8;else continue;push.c=0;break;
							case  5888:if(na==1 && hztal!=9) hztal=9;else continue;push.c=0;break;
							case  7936:if(hztal!=10) hztal=10;else continue;push.c=0;break;
							default   :if(isgraph(push.ch[0])==0 && push.ch[0]!=' ') continue;
						 }break;
					 }
					else break;
				 }
				setcolor(7);rectangle(x,y,x+ne,y+subcarp);setcolor(CF);rectangle(x+1,y+1,x+ne-1,y+subcarp-1);settextstyle(0,0,0);
				if(hztal>=0 && hztal<nx && (push.c==0 || (push.ch[1]==75 && hztal>0) || (push.ch[1]==77 && hztal<4))) { rectangle(36,116,202+(lci*8-160),131);borralins(); }
				vernreg_pag(cont,nrx,pginc,numpg);
				outtextxy(300,455,itoa(regsxadq,aux,10)); //prueba (tot. adq.)
				if(push.c==0) continue;
				if(nrx>0 && push.ch[1]!=15 && push.ch[1]!=75 && push.ch[1]!=77 && push.ch[1]!=28)
				 {                                                             //^este hace que no quite resalto y se vea en impirmir
					setcolor(getpixel(372,62));recuadrclasif(vcs[cia]);
					setcolor(CF);outtextxy(30,160+vtcal*SP,">");
					setcolor((vcs[cia].existencia==vcs[cia].prestados+vcs[cia].numresrva || vcs[cia].existencia==0) ? 4 : 2);
					opcmuestralib(cia,vtcal,a,b,c,vcs);
				 }
				if(push.ch[1]!=15 && (push.ch[1]==1 || push.ch[1]==28 || push.ch[1]==72 || push.ch[1]==73 || push.ch[1]==75 || push.ch[1]==77 || push.ch[1]==80 || push.ch[1]==81))
				 {
					setcolor(CF);outtextxy(40+mas*8,122,"_"); //Borrar de pantalla
					outtextxy(40,120,ndx.atet);mas=0;ndx.atet[0]='\0'; //cursor y texto del recuadro de buscar
				 }
				if(push.ch[1]==28 && hztal<10) { nomypestsup(CF,CF);abcarpinfynom(CF,CF);accion(hztal,11); }
				switch(push.ch[1])
				 {
					case 72: /*Flecha arriba*/
					 if(vtcal>0) { cont-=1;vtcal-=1;cia-=1; }
					 else
						if(pginc>0)
						 {
							pgcia-=1;cia-=1;
							if(pgcia<0)
							 {
								for(pgcia=PL-1,mas=0,cia=rpg=(NRP+1)*PL;mas<=NRP;mas+=1,rpg+=1)
								 { vcs[rpg]=vcs[mas];vindex[rpg]=vindex[mas]; }		    //Asigna los primeros NRP registros a los ltimos
								fseek(fpx,sizeof(vindex[mas])*(NRP+1)*(pginc-PL),0);  //Posicionarse en la lect de las sig PL anteriores pantallas
								for(cia-=1,mas=0;mas<(NRP+1)*PL;mas+=1)
								 {
									fread(&vindex[mas],sizeof(vindex[mas]),1,fpx);      //Lee reg del ndice para
									fseek(fbd,vindex[mas].posicion*sizeof(vcs[mas]),0); //posicionarse en base maestra y
									fread(&vcs[mas],sizeof(vcs[mas]),1,fbd);            //leer todos los datos
								 }nrcia=rpg;rpg=mas=0;
							 }pginc-=1;pgdec+=1;cont-=1;vtcal=NRP;borralins();muestralib(pgcia*(NRP+1),nrcia,a,b,c,vcs);
						 }break;
					case 73: /*Re pg*/
					 if(pginc>0)
						{
						 pgcia-=1;
						 if(pgcia<0)
							{
							 for(pgcia=PL-1,mas=0,rpg=(NRP+1)*PL;mas<=NRP;mas+=1,rpg+=1)
								{ vcs[rpg]=vcs[mas];vindex[rpg]=vindex[mas]; }
							 fseek(fpx,sizeof(vindex[mas])*(NRP+1)*(pginc-PL),0);
							 for(mas=0;mas<(NRP+1)*PL;mas+=1)
								{
								 fread(&vindex[mas],sizeof(vindex[mas]),1,fpx);
								 fseek(fbd,vindex[mas].posicion*sizeof(vcs[mas]),0);
								 fread(&vcs[mas],sizeof(vcs[mas]),1,fbd);
								}nrcia=rpg;rpg=mas=0;
							}pginc-=1;pgdec+=1;cont=pginc*(NRP+1);vtcal=0;cia=pgcia*(NRP+1);borralins();muestralib(cia,nrcia,a,b,c,vcs);
						}break;
					case 80: /*Flecha abajo*/
					 if(vtcal<NRP && cont<nrx-1) { cont+=1;vtcal+=1;cia+=1; }
					 else
						if(vtcal>=NRP && cont<nrx-1)
						 {
							pginc+=1;pgdec-=1;cont+=1;vtcal=0;pgcia=((pgcia+1)>PL) ? 1 : pgcia+1;cia+=1;
							if(cia==MAXR)
							 {
								for(nrcia=0,mas=cont-(NRP+1),rpg=(NRP+1)*PL;nrcia<=NRP;nrcia+=1,rpg+=1,mas+=1)
								 { vcs[nrcia]=vcs[rpg];vindex[nrcia]=vindex[rpg]; } //Los ltimos NRP registros sern los primeros
								fseek(fpx,sizeof(vindex[nrcia])*cont,0);            //Posicionarse en la lect de las sig PL pantallas
								for(;mas<nrx && nrcia<MAXR;nrcia+=1,mas+=1)
								 {
									fread(&vindex[nrcia],sizeof(vindex[nrcia]),1,fpx);
									fseek(fbd,vindex[nrcia].posicion*sizeof(vcs[nrcia]),0);
									fread(&vcs[nrcia],sizeof(vcs[nrcia]),1,fbd);
								 }rpg=mas=0;
							 }cia=pgcia*(NRP+1);borralins();muestralib(cia,nrcia,a,b,c,vcs);
						 }break;
					case 81: /*Av pg*/
					 if(pginc<numpg)
						{
						 pginc+=1;pgdec-=1;
						 cont=pginc*(NRP+1);vtcal=0; //Al cargar,cont se ubica al inicio de la siguiente pgina
						 mas=cont-(NRP+1); //Asigna inicio una pgina antes
						 pgcia+=1;cia=pgcia*(NRP+1);
						 if(cia==MAXR)
							{
							 for(nrcia=0,rpg=(NRP+1)*PL;nrcia<=NRP;nrcia+=1,rpg+=1,mas+=1)
								{ vcs[nrcia]=vcs[rpg];vindex[nrcia]=vindex[rpg]; }
							 fseek(fpx,sizeof(vindex[nrcia])*cont,0);
							 for(;mas<nrx && nrcia<MAXR;nrcia+=1,mas+=1)
								{
								 fread(&vindex[nrcia],sizeof(vindex[nrcia]),1,fpx);
								 fseek(fbd,vindex[nrcia].posicion*sizeof(vcs[nrcia]),0);
								 fread(&vcs[nrcia],sizeof(vcs[nrcia]),1,fbd);
								}rpg=mas=0;
							}if(pgcia>PL) { pgcia=1;cia=pgcia*(NRP+1); }borralins();muestralib(cia,nrcia,a,b,c,vcs);
						}mas=0;break;
					case 75:if(na==0 && hztal==10) hztal=0;else hztal=(hztal>0) ? hztal-1 : NC-1;break;
					case 77:hztal=(hztal<NC-1) ? hztal+1 : 0;break;
					case 15: /*Tab*/
					 hztal=(hztal<nx && na==1) ? 5 : (hztal==nx && carp!=0 && na==1) ? 5 : carpx; //Pestaa primera de abajo o retorna a la pestaa de consulta
					case  1: /*Esc*/
					case 28: /*Enter*/
					 if(hztal==10) push.ch[1]=1;break;
					default:if(nrx==0) break;
					 if(push.ch[1]==14 && mas>0)
						{
						 setcolor(CF);aux[0]=ndx.atet[mas-1];aux[1]='\0';
						 outtextxy(40+(mas-1)*8,120,aux);outtextxy(40+mas*8,122,"_");
						 ndx.atet[--mas]='\0';
						 setcolor(7);outtextxy(40+mas*8,122,"_");
						}
					 else if((isgraph(push.ch[0])!=0 || push.ch[0]==' ') && mas<lci)
								 {
									setcolor(CF);outtextxy(40+mas*8,122,"_");
									ndx.atet[mas++]=push.ch[0];ndx.atet[mas]='\0';
									setcolor(7);aux[0]=ndx.atet[mas-1];aux[1]='\0';
									outtextxy(40+(mas-1)*8,120,aux);
									if(mas<lci) outtextxy(40+mas*8,122,"_"); //No aparece cursor si se pasa del recuadro
								 }
								else break; //Fue tecla de funcin o especial,mas=0  mas=lci
					 if((pos=buscarr(vindex,nrcia,ndx.atet,1))>=0 && pos<MAXR) //Busca primero en arreglo de indexado
						{
						 if(pos==nrcia) pos-=1;     //Porque nrcia va uno adelante
						 if(pos<cia) cont-=(cia-pos);
						 else if(pos>cia) cont+=(pos-cia);else break; //Ubica contador de registros
						 brk=cont/(NRP+1);          //Si pos!=cia,entonces ubica pgina real
						 pgdec=numpg-brk;           //Pagina inversa
						 cia=pos;vtcal=pos%(NRP+1); //Ubica contador interno de arreglo y de pgina
						 pgcia=cia/(NRP+1);         //Ubica pgina relativa
						}
					 else //Se ver si busca fuera del arreglo
						switch(pos) //Necesario para salir sin hacer bsqueda
						 {
							case -1:if(pgcia==pginc) { cont=cia=vtcal=pgcia=brk=0;break; } //Se est en las primeras PL+1 pg.
							case MAXR:
							 if(pos==MAXR)
								if(numpg<=PL || pgdec<PL) //Slo hay PL+1 pg. o el arreglo esta en las ltimas PL+1 pginas
								 {
									pos-=1;
									if(pos<cia) cont-=(cia-pos);
									else if(pos>cia) cont+=(pos-cia);else break; //Ubica contador de registros
									brk=cont/(NRP+1);          //Si pos!=cia,entonces ubica pgina real
									pgdec=numpg-brk;           //Pagina inversa
									cia=pos;vtcal=pos%(NRP+1); //Ubica contador interno de arreglo y de pgina
									pgcia=cia/(NRP+1);break;   //Ubica pgina relativa
								 }
							 pos=buscax(fpx,nrx,ndx.atet,1); //Busca ubicacin en indexado primario
							 if(pos==-1) { brk=pgcia=cia=cont=vtcal=0;pgdec=numpg; } //Mostrar desde la primer pgina
							 else
								{
								 if(pos==nrx) pos-=1;
								 brk=pos/(NRP+1);            //Ubica en pgina real
								 cia=(brk<=PL) ? brk*(NRP+1)+pos%(MAXR-(NRP+1)) : PL*(NRP+1)+pos%(MAXR-(NRP+1)); //Ubica contador de arreglo
								 if(cia>=(PL+1)*(NRP+1)) cia-=PL*(NRP+1);
								 pgcia=cia/(NRP+1);          //Ubica en pgina de referencia (relativa)
								 pgdec=numpg-brk;            //Pgina inversa
								 cont=pos;vtcal=pos%(NRP+1); //Ubica contadores de:registros y registros de pgina
								}
							 rpg=(brk-pgcia)*(NRP+1);
							 fseek(fpx,rpg*sizeof(vindex[0]),0); //Posiciona puntero para cargar siguientes PL+1 pginas
							 for(nrcia=0;nrcia<MAXR && rpg<nrx;nrcia+=1,rpg+=1)
								{
								 fread(&vindex[nrcia],sizeof(vindex[nrcia]),1,fpx);
								 fseek(fbd,vindex[nrcia].posicion*sizeof(vcs[nrcia]),0);
								 fread(&vcs[nrcia],sizeof(vcs[nrcia]),1,fbd);
								}rpg=0;
						 }
					 if(brk!=pginc)	{ pginc=brk;borralins();muestralib(pgcia*(NRP+1),nrcia,a,b,c,vcs);mensabc(1,10); }
				 }
			 }while(push.ch[1]!=1 && push.ch[1]!=28);
		 if(push.ch[1]==28 && (nrx>0 || hztal==5))
			{
			 auto int t,lec;
			 if(hztal==5) //Slo en caso de altas
				{ //Tt(catlogo)+MT(materias)+4(Clasif nd temporal+ndice por clasif+adq nd temporal+nd por adq)+Tt+adq(backup's)
				 size=sizeof(reg)+(MT+4)*sizeof(ndx)+sizeof(adqui)+(BK[0]!='@') ? sizeof(reg)+sizeof(adqui) : 0;
				 if(espacioendisco(sizedisk,unidad)<=size) { borralins();mensmoment(405,"! ESPACIO INSUFICIENTE EN DISCO PARA AGREGAR MAS TITULOS !",2);accion(hztal,CF);mensabc(1,10);continue; }
				}
			 if(hztal!=9)
				{
				 setcolor(CF);rectangle(36,116,202+(lci*8-160),131);
				 if(push.ch[1]==28 && (na==0 || (hztal>=0 && hztal<nx))) { brk=hztal;hztal=8; }  //Presion ENTER en modo slo consulta o en pestaas superiores
				 if(hztal>4 && hztal<9) vercampsbib(na);
				}
			 switch(hztal)
				{
				 case 5: /*Agregar*/
					ctalt=opc.ch[1]=0;reg=vcs[cia];
					while(1)
					 {
						if(nrx>0 || ctalt>0) { setcolor(getpixel(372,62));recuadrclasif(reg); }//Oculta datos del recuadro clasif.
						settextstyle(0,0,0);
						if(ctalt>0) vercampsbib(na); //Borra datos de carpeta luego de la primer alta
						inicia(reg.titul,40);inicia(reg.autor,30);inicia(reg.campo3,20);inicia(reg.edicio,19);inicia(reg.clasif,30);
						inicia(reg.anio,4);inicia(reg.num,3);inicia(reg.volume,3);reg.prestamo=reg.consul=' ';
						inicia(csf0,14);inicia(csf1,14);
						for(reg.existencia=reg.prestados=reg.numresrva=adqui.numejemp=lec=t=brk=pos=mdfadq=0;brk<MT;brk+=1) inicia(reg.temas[brk],40);
						setcolor(1);outtextxy(307,190,itoa(reg.prestados,aux,10));outtextxy(403,190,itoa(reg.existencia,aux,10));
						while(strlen(reg.clasif)==0 || strlen(reg.titul)==0 || strlen(reg.autor)==0 || strlen(reg.campo3)==0 || adqui.numejemp==0 || (opc.ch[1]!=1 && opc.ch[1]!=60))
						 {
							opc.ch[1]=0;settextstyle(0,0,0);
							switch(lec)
							 {
								case 0:lec=0;
								 while(1)
									{
									 mensmov(0,15);settextstyle(2,0,4);
									 while(opc.ch[1]!=1) { leekb41(520,65,csf0,14,9,'D',strlen(csf0),&opc);if(strlen(csf0)>0) break; }
									 while(opc.ch[1]!=1) { leekb41(520,76,csf1,10,9,'A',strlen(csf1),&opc);if(strlen(csf1)>0) break; }
									 if(opc.ch[1]==72) break;
									 if(opc.ch[1]!=1 && opc.ch[1]!=60)
										{
										 for(strcpy(reg.clasif,csf0),brk=strlen(csf0);brk<15;brk+=1) reg.clasif[brk]=' '; //Rellena con espacios
										 reg.clasif[brk]='\0';strcat(reg.clasif,csf1); //Adiciona la otra parte
										 settextstyle(0,0,0);
										 if((ftmp=fopen(SCBTMP[0],"rb"))!=NULL)
											if(buscax(ftmp,ctalt,reg.clasif,0)>=0) //Busca coincidencia en temporal de altas
											 { mensmov(0,CF);mensmoment(405,"LA CLASIFICACION COINCIDE CON OTRA",2);fclose(ftmp);continue; }
											else fclose(ftmp);
										 if((ftmp=fopen(IND[nx-1],"rb"))!=NULL)
											if(buscax(ftmp,regs,reg.clasif,0)>=0) //Busca coincidencia en indexado por clasif.
											 { mensmov(0,CF);mensmoment(405,"LA CLASIFICACION COINCIDE CON OTRA",2);fclose(ftmp); }
											else { fclose(ftmp);break; } //Clasif. no se repite
										 else break; //No se repite clasif.,por no haber temporales o ndice por clasif.
										}
									 else break; //Esc  F2
									}if(opc.ch[1]==1 || opc.ch[1]==60) break;
								 if(opc.ch[1]==72) { opc.ch[1]=0;lec=9;continue; }lec=1;
								default:ndx.posicion=regs;reg=leedatosbib(&lec,&t,&reg,0,&y);
							 }if(opc.ch[1]==1) break;
						 }settextstyle(0,0,0);ndx.atet[0]='\0';mensmov(0,CF);borralins();setcolor(getpixel(372,62));recuadrclasif(reg);
						if(opc.ch[1]!=1) //No procede alta de ltima pantalla
						 {
							strcpy(ndx.atet,reg.clasif); //Copia posicin y clasif.
							if((fdx=fopen(SCBTMP[0],"rb+"))==NULL) fdx=fopen(SCBTMP[0],"wb+");
							fseek(fdx,ctalt*sizeof(ndx),0);fwrite(&ndx,sizeof(ndx),1,fdx);
							insercion(fdx,ctalt+1,1);fclose(fdx); //Indexa temporal ctalt+1:porque an no se incrementa y libera puntero
							mensajes(405,"Guardando ttulo nuevo...",15);
							if(fopen(BD,"rb")==NULL) fbd=fopen(BD,"wb+");
							fseek(fbd,regs*sizeof(reg),0);fwrite(&reg,sizeof(reg),1,fbd);
							if(BK[0]!='@')
							 {
								if((ftmp=fopen(BK,"rb+"))==NULL) ftmp=fopen(BK,"wb+");
								fseek(ftmp,regs*sizeof(reg),0);fwrite(&reg,sizeof(reg),1,ftmp);fclose(ftmp);
							 }
							if((fdx=fopen(IND[nx-1],"rb+"))==NULL) fdx=fopen(IND[nx-1],"wb+");
							fseek(fdx,regs*sizeof(ndx),0);fwrite(&ndx,sizeof(ndx),1,fdx);fclose(fdx);
							altbajadq(0);rpg=1;regs+=1;ctalt+=1;mensajes(405,"Guardando ttulo nuevo...",CF);
							size=sizeof(reg)+(MT+4)*sizeof(ndx)+sizeof(adqui)+(BK[0]!='@') ? sizeof(reg)+sizeof(adqui) : 0;
							if(espacioendisco(sizedisk,unidad)<=size) { mensmov(0,CF);mensmoment(405,"! ESPACIO INSUFICIENTE EN DISCO PARA AGREGAR MAS TITULOS !",2);break; }
						 }
						else break;
					 }break;
				 case 6: /*Quitar*/
				 case 7: /*Modificar*/
				 case 8: /*Ver ms*/
					ejemplar=reg=vcs[cia];ndx.posicion=vindex[cia].posicion;verdatosbib(reg);if(hztal!=8) abcpadqui(-2);
					if(na<2)
					 {
						pos=0;
						switch(hztal)
						 {
							case 6:
							 if(reg.prestados==0)
								{
								 mensajes(405,"Est seguro que lo quiere dar de baja? (S/N): ",15);
								 do{ opc.c=obtentecla(); }while(opc.ch[1]!=1 && toupper(opc.ch[0])!='S' && toupper(opc.ch[0])!='N');
								 mensajes(405,"Est seguro que lo quiere dar de baja? (S/N): ",CF);
								 if(toupper(opc.ch[0])=='S') nrb=rpg=1;else remove(SCBTMP[1]);
								}
							 else { mensajes(390,"NO PUEDE DAR DE BAJA ESTE TITULO",14);mensajes(405,"EXISTEN EJEMPLARES EN PRESTAMO",14);obtentecla();	}break;
							case 7:if(reg.prestados>0) { mensajes(390,"NO PUEDE MODIFICAR ESTE TITULO",14);mensajes(405,"EXISTEN EJEMPLARES EN PRESTAMO",14);break; }
							 for(mdfadq=rec=lec=opc.ch[1]=0,brk=strlen(csf0)-1;csf0[brk]==' ';brk-=1) csf0[brk]='\0'; //Quita espacios de ms
							 while(strlen(reg.clasif)==0 || strlen(reg.titul)==0 || strlen(reg.autor)==0 || strlen(reg.campo3)==0 || adqui.numejemp==0 || (opc.ch[1]!=1 && opc.ch[1]!=60))
								{
								 opc.ch[1]=0;settextstyle(0,0,0);
								 switch(lec)
									{
									 case 0:lec=0;
										while(1)
										 {
											settextstyle(0,0,0);mensmov(1,15);settextstyle(2,0,4);
											while(opc.ch[1]!=1) { leekb41(520,65,csf0,14,9,'D',strlen(csf0),&opc);if(strlen(csf0)>0) break; }
											while(opc.ch[1]!=1) { leekb41(520,76,csf1,10,9,'A',strlen(csf1),&opc);if(strlen(csf1)>0) break; }
											if(opc.ch[1]==72) break;
											if(opc.ch[1]!=1 && opc.ch[1]!=60)
											 {
												for(strcpy(reg.clasif,csf0),brk=strlen(csf0);brk<15;brk+=1) reg.clasif[brk]=' ';
												reg.clasif[brk]='\0';
												strcat(reg.clasif,csf1);settextstyle(0,0,0);
												if(strcmp(reg.clasif,vcs[cia].clasif)!=0) //Ve si cambi clasif.
												 if((ftmp=fopen(IND[nx-1],"rb+"))!=NULL)
													if(buscax(ftmp,regs,reg.clasif,0)>=0)
													 { mensmov(1,CF); mensmoment(405,"LA CLASIFICACION COINCIDE CON OTRA",2);fclose(ftmp); }
													else { fclose(ftmp);break; } //Hubo cambios en clasif.,luego guardar cambios
												 else break; //Error al abrir ndice por clasif.
												else break; //Clasif. no cambia
											 }
											else break; //Esc  F2
										 }if(opc.ch[1]==1 || opc.ch[1]==60) break;
										if(opc.ch[1]==72) { opc.ch[1]=0;lec=9;continue; }lec=1;
									 default:reg=leedatosbib(&lec,&rec,&reg,1,&y);
									}if(opc.ch[1]==1 && reg.existencia>0) break;
								}settextstyle(0,0,0);mensmov(1,CF);ndx.atet[0]='\0';borralins();
							 if(opc.ch[1]!=1 || y==-2) //Guarda cambios si los hubo y reindexa
								{
								 mensajes(405,"Guardando los cambios...",15);
								 if(pos>0) altbajadq(1);else remove(SCBTMP[1]); //Slo si hay altas sino slo borra temporal
								 if(opc.ch[1]!=1)
									{
									 if(strcmp(vcs[cia].clasif,reg.clasif)!=0)
										{
										 ndx.posicion=vindex[cia].posicion;
										 strcpy(ndx.atet,reg.clasif);
										 ftmp=fopen(IND[nx-1],"rb+");
										 pos=buscax(ftmp,regs,vcs[cia].clasif,1); //Busca clasif. vieja para
										 fseek(ftmp,pos*sizeof(ndx),0);fwrite(&ndx,sizeof(ndx),1,ftmp); //posicionarse y guardar cambios
										 reindexa(ftmp,regs,pos);fclose(ftmp);
										}
									 switch(carpx) //Copia el campo (NO POR TEMA) al arreglo en caso de que el cambio
										{            //permanezca en la misma posicin
										 case 0:strcpy(vindex[cia].atet,reg.titul);break;
										 case 1:strcpy(vindex[cia].atet,reg.autor);break;
										 case 2:strcpy(vindex[cia].atet,reg.campo3);
										}
									 for(mas=0;mas<nx-1;mas+=1) //Guarda cambios y actualiza cada ndice
										{
										 fclose(fpx);fpx=fopen(IND[mas],"rb+");
										 if(mas<3)
											{
											 if(mas==0) pos=buscax(fpx,regs,vcs[cia].titul,1);
											 else if(mas==1) pos=buscax(fpx,regs,vcs[cia].autor,1);
														else pos=buscax(fpx,regs,vcs[cia].campo3,1);
											 fseek(fpx,pos*sizeof(ndx),0);
											 do{ fread(&ndx,sizeof(ndx),1,fpx);if(ndx.posicion==vindex[cia].posicion) break;pos+=1; }while(1);
											 if(mas==0) strcpy(ndx.atet,reg.titul);
											 else if(mas==1) strcpy(ndx.atet,reg.autor);else strcpy(ndx.atet,reg.campo3);
											 fseek(fpx,pos*sizeof(ndx),0);fwrite(&ndx,sizeof(ndx),1,fpx);
											 if(mas==carpx) camb=reindexa(fpx,regs,pos); //Si ndice primario tuvo reacomodo
											 else reindexa(fpx,regs,pos);
											}
										 else //Guarda cambios por materia
											{
											 for(rec=0;rec<MT;rec+=1)
												if(reg.temas[rec][0]!='\0')
												 if(vcs[cia].temas[rec][0]!='\0') //Ve si no est vaco el viejo
													{
													 if(strcmp(vcs[cia].temas[rec],reg.temas[rec])!=0) //Si es diferente viejo y cambio,entonces
														{
														 pos=buscax(fpx,nrtx,vcs[cia].temas[rec],1);     //busca tema viejo para
														 fseek(fpx,pos*sizeof(ndx),0);                   //posicionarse y
														 do{ fread(&ndx,sizeof(ndx),1,fpx);if(ndx.posicion==vindex[cia].posicion) break;pos+=1; }while(1); //mientras se lee hasta coincidir con la posicin y as
														 strcpy(ndx.atet,reg.temas[rec]); //copiar cambio,
														 fseek(fpx,pos*sizeof(ndx),0);fwrite(&ndx,sizeof(ndx),1,fpx); //posicionarse,guardar ste y
														 reindexa(fpx,nrtx,pos); //reindexa
														 if(mas==carpx) camb=1; //Tenga o no reacomodo mostrar desde el inicio
														}
													}
												 else //Si estaba vaco,hay que incorporar
													{
													 ndx.posicion=vindex[cia].posicion;
													 strcpy(ndx.atet,reg.temas[rec]);
													 fseek(fpx,nrtx*sizeof(ndx),0);fwrite(&ndx,sizeof(ndx),1,fpx); //Se posiciona un lugar delante del ltimo reg. para incorporar tema y
													 nrtx+=1;reindexa(fpx,nrtx,nrtx-1); //se reindexa
													 if(mas==carpx) camb=1;rpg=1;
													}
												else //Borra materia del ndice si cambio es vaco
												 if(vcs[cia].temas[rec][0]!='\0')
													{
													 pos=buscax(fpx,nrtx,vcs[cia].temas[rec],1);
													 fseek(fpx,pos*sizeof(ndx),0);
													 do{ fread(&ndx,sizeof(ndx),1,fpx);if(ndx.posicion==vindex[cia].posicion) break;pos+=1; }while(1);
													 size=2*nrtx*sizeof(ndx); //Espacio de ndice por materia y arch. temporal de intercambio
													 if(espacioendisco(sizedisk,unidad)<=size) { mensmoment(405,"! INSUFICIENTE ESPACIO EN DISCO PARA QUITAR MATERIA !",2);break; }
													 else { nrtx=recorrx(fpx,IND[mas],nrtx,pos);if(mas==carpx) camb=1;rpg=1; } //Da de baja en la posicin pos
													}
											}
										}
									}
								 if(carp==0 && carpx==3)
									for(mas=rec=0;camb==0 && rec<MT && mas<nrcia;mas+=1)
									 if(vindex[mas].posicion==vindex[cia].posicion)	{ vcs[mas]=reg;rec+=1; }
								 mas=0;vcs[cia]=reg; //Asigna los cambios
								 fseek(fbd,vindex[cia].posicion*sizeof(vcs[cia]),0); //Posiciona en maestro para
								 fwrite(&vcs[cia],sizeof(vcs[cia]),1,fbd);           //guardar cambios
								 if(BK[0]!='@')
									{
									 fdx=fopen(BK,"rb+");
									 fseek(fdx,vindex[cia].posicion*sizeof(vcs[cia]),0); //Posiciona en backup del maestro para
									 fwrite(&vcs[cia],sizeof(vcs[cia]),1,fdx);fclose(fdx); //guardar cambios
									}mensajes(405,"Guardando los cambios...",CF);
								}
							 else { remove(SCBTMP[1]);setcolor(getpixel(372,62));recuadrclasif(reg); }break;
							case 8:abcpadqui(-1);remove(SCBTMP[1]);if(push.ch[1]==28 && na==0) hztal=brk; //Recobra valor slo en modo consulta o dio ENTER en pestaas sup.
						 }
					 }
					else
					 {
						if(reg.prestados<reg.existencia)
						 {
							abcpadqui(2);
							if(opc.ch[1]==28)
							 {
								reg.prestados+=1; //Incrementa al realizarse el prstamo del ejemplar
								fseek(fbd,vindex[cia].posicion*sizeof(reg),0); //Se posiciona en maestro para
								fwrite(&reg,sizeof(reg),1,fbd);                //guardar los cambios en prestados
								if(BK[0]!='@')
								 {
									fdx=fopen(BK,"rb+");
									fseek(fdx,vindex[cia].posicion*sizeof(reg),0); //Se posiciona en backup para
									fwrite(&reg,sizeof(reg),1,fdx);fclose(fdx);		 //guardar los cambios en prestados
								 }ndx=vindex[cia];ejemplar=reg; //Posicin y datos del ttulo seleccionado
							 }
						 }
						else if(reg.existencia==0) mensmoment(405,"EXISTENCIA DE TITULO EN CERO",0); //Este no se da
								 else mensmoment(405,"TODO EL TITULO ESTA PRESTADO",0);
						if(opc.ch[1]==1) hztal=10;else hztal=brk; //salir o buscar otro para prstamo
					 }borralins();break;
				 case 9:mensabc(1,CF);ndx.posicion=vindex[cia].posicion;impbib(); /*Imprimir*/
				}if(na==1) push.c=0; //Para volver a poner encabezado de listado
			 if((ctalt>0 || camb!=0 || nrb==1) && regs>0)	//Elimina baja u ordena altas
				{
				 setcolor(getpixel(372,62));recuadrclasif(reg);
				 if(nrb==1) //Elimina baja
					{
					 size=2*regs*sizeof(reg); //Maestro y Arch. temporal de intercambio
					 if(espacioendisco(sizedisk,unidad)<=size) { mensmoment(405,"! INSUFICIENTE ESPACIO EN DISCO PARA REALIZAR LA OPERACION !",2);nrb=0; }
					 else
						{
						 mensajes(405,"Dando de baja el ttulo...",15);
						 regs=recorrbib(fbd,BD,regs,vindex[cia].posicion);
						 fcloseall(); //Cierra todo para reindexar
						 altbajadq(1); //Baja de adquisiciones
						 if(BK[0]!='@') { fbd=fopen(BK,"rb+");recorrbib(fbd,BK,regs,vindex[cia].posicion); } //Actualiza backup,necesario fbd por usarse en recorrbib()
						 mensajes(405,"Dando de baja el ttulo...",CF);
						 creaindex(regs);
						 if(carp==0) nrtx=regsxmat; //En creaindex() se retoma regsxmat
						 fbd=fopen(BD,"rb+"); //Maestro debe permanecer abierto
						 fpx=fopen(IND[carpx],"rb+"); //Se requiere abierto para siguiente paso
						}
					}mensajes(405,"Actualizando bases de datos...",15);
				 if(ctalt>0)
					{
					 remove(SCBTMP[0]); //Donde fueron grabadas las clasif. dadas de alta
					 for(mas=0;mas<nx-1;mas+=1) //Incorpora altas en todos los ndices,menos por clasif.
						{
						 fclose(fpx);
						 if((fpx=fopen(IND[mas],"rb+"))==NULL)	fpx=fopen(IND[mas],"wb+");
						 cont=(mas==3 && carp==0) ? nrtx : regs-ctalt; //Para ubicar en ndice IND[]
						 fseek(fpx,cont*sizeof(ndx),0);
						 cont=regs-ctalt; //Una posicin adelante del ltimo registro antes de dar de alta
						 fseek(fbd,cont*sizeof(reg),0);
						 for(;cont<regs;cont+=1) //Guarda en ndices
							{
							 fread(&reg,sizeof(reg),1,fbd);ndx.posicion=cont;
							 switch(mas)
								{
								 case 0:strcpy(ndx.atet,reg.titul);fwrite(&ndx,sizeof(ndx),1,fpx);break;
								 case 1:strcpy(ndx.atet,reg.autor);fwrite(&ndx,sizeof(ndx),1,fpx);break;
								 case 2:strcpy(ndx.atet,reg.campo3);fwrite(&ndx,sizeof(ndx),1,fpx);break;
								 case 3:for(rec=0;rec<MT;rec+=1)
												 if(reg.temas[rec][0]!='\0') { strcpy(ndx.atet,reg.temas[rec]);fwrite(&ndx,sizeof(ndx),1,fpx);nrtx+=1;ctaltem+=1; }
								}
							}
						}
					 ftmp=fopen(IND[nx-1],"rb+");
					 if(regs>ctalt && regs>2) //Y aqu los ordena:Cuando hay registros y altas
						for(insercion(ftmp,regs,ctalt),mas=0;mas<nx-1;mas+=1) //Actualiza todos los ndices
						 {
							fclose(fpx);fpx=fopen(IND[mas],"rb+");
							switch(mas)
							 {
								case 0:
								case 1:
								case 2:insercion(fpx,regs,ctalt);break; //por titulo,autor o campo3
								case 3:insercion(fpx,nrtx,ctaltem); //por materia
							 }
						 }
					 else //Cuando no hay registros,pero hay altas
						for(insercion(ftmp,regs,regs-1),mas=0;mas<nx-1;mas+=1)
						 {
							fclose(fpx);fpx=fopen(IND[mas],"rb+");
							switch(mas)
							 {
								case 0:
								case 1:
								case 2:insercion(fpx,regs,regs-1);break;
								case 3:insercion(fpx,nrtx,nrtx-1);
							 }
						 }fclose(ftmp);
					}
				 fclose(fpx);fpx=fopen(IND[carpx],"rb+"); //Abre para el ndice primario
				 nrx=(carp==0 && carpx==3) ? nrtx : regs;
				 for(nrcia=0;nrcia<nrx && nrcia<MAXR;nrcia+=1) //Leer primeros MAXR o nrx registros del ndice
					{
					 fread(&vindex[nrcia],sizeof(vindex[nrcia]),1,fpx);
					 fseek(fbd,vindex[nrcia].posicion*sizeof(vcs[nrcia]),0);
					 fread(&vcs[nrcia],sizeof(vcs[nrcia]),1,fbd);
					}
				 if(ctalt>0 || nrb>0 || camb!=0) { camb=nrb=ctalt=ctaltem=cont=vtcal=pginc=pgdec=cia=pgcia=0; }  //Para que muestre listado desde el inicio
				 mas=0;mensajes(405,"Actualizando bases de datos...",CF);
				}
			}
		 else	if(push.ch[1]!=1)	mensmoment(250,"! REGISTRO INDICE DE DATOS VACIO !",1);
		 if(push.ch[1]!=1 && hztal<10) accion(hztal,CF);
		}while(push.ch[1]!=1 && hztal<10); }
	fcloseall();
	if(regs==0) //Borra archivos ndices y maestro al no existir registros
	 {
		remove(BD);if(BK[0]!='@') remove(BK); //Archivo maestro y backup
		for(rec=0;rec<nx;rec+=1) remove(IND[rec]); //Archivos ndices
		if(carp==0) regsxmat=0;
		remove(BDADQ);if(BKADQ[0]!='@') remove(BKADQ);remove(ADQNDX);regsxadq=0; //Archivos maestro,backup e ndice por adquisicin
	 }
	else if(carp==0) regsxmat=nrtx;
	setcolor(CF);settextstyle(3,0,1); //Borra lo sig:
	outtextxy((640-textwidth(titcarp))/2,50,titcarp); //ttulo fichero
	rectangle(36,116,202+(lci*8-160),131); //recuadro de ttulo de bsqueda y cursor
	borralins();nomypestsup(CF,CF);
	setfillstyle(getpixel(371,61),CF);floodfill(371,61,14);
	rectangle(368,58,621,107);rectangle(370,60,619,105); //recuadro clasif.
	abcarpinfynom(CF,CF);rectangle(x+1,y+1,x+ne-1,y+subcarp-1);
 }



/*JSoft Corporation. (C) Reservados todos los derechos 2002*/