/*Funcin: FADQUI.CPP
	Proceso: Agregar, Modificar, Consulta y Seleccin de nm. de adquisicin
	Funciones que llaman: abcbib(),leedatosbib(),fprest()
	Devuelve: 1=Hubo modif.,0=Slo ver 1er. pantalla/No modif.,-1=No hay espacio,-2=Archivos no corresponden,-3=Arch. adq. no existe*/

int abcpadqui(int abcp)
 {
	struct adqdat vadq[NRP];
	int pginc,numpg,rpg=1,nrcia=0,vtcal,cont,ctaltadq,eje,adq,fe,fs;
	char numeje[3],numadq[7],numenv[10],fechent[11],fechsal[11];
	if(abcp!=-2) mensadqui(abcp,15);
	if((fad=fopen(SCBTMP[1],"rb+"))==NULL)
	 if((fad=fopen(BDADQ,"rb+"))!=NULL)
		if(buscadq(fad,regsxadq,ndx.posicion,0)>=0) //Busca el nm de posicin del ttulo en maestro por adq.
		 {
			posinc=buscadq(fad,regsxadq,ndx.posicion,1); //Busca el primer de los ejemplares con el nm de posicin
			fseek(fad,posinc*sizeof(adqui),0);
			for(;nrcia<ejemplar.existencia && nrcia<NRP;nrcia+=1) fread(&vadq[nrcia],sizeof(vadq[nrcia]),1,fad);
			fclose(fad);
			if(abcp!=-2)
			 {
				size=sizeof(adqui);
				ftmp=fopen(BDADQ,"rb");fseek(ftmp,posinc*sizeof(adqui),0);
				fad=fopen(SCBTMP[1],"wb"); //Crea el temporal
				for(cont=0;cont<ejemplar.existencia;cont+=1) //Guarda adq. existentes en temporal
				 if(espacioendisco(sizedisk,unidad)<=size)
					{
					 mensadqui(abcp,CF);settextstyle(0,0,0);mensmoment(405," ESPACIO INSUFICIENTE EN DISCO PARA REALIZAR LA OPERACION !",2);mensadqui(abcp,15);
					 cont=-1;remove(SCBTMP[1]);break;
					}
				 else { fread(&adqui,sizeof(adqui),1,ftmp);fwrite(&adqui,sizeof(adqui),1,fad); }
				fclose(ftmp);fclose(fad);
				if(cont==-1) return -1;
				fad=fopen(SCBTMP[1],"rb+");ctaltadq=0; //Este es el archivo con el cual se trabaja directamente con altas,bajas y modif.
			 }
		 }
		else
		 {
			fclose(fad);
			if(ejemplar.existencia>0) { mensadqui(abcp,CF);settextstyle(0,0,0);mensmoment(405,"ERROR: ARCHIVO DE ADQUISICIONES NO CORRESPONDE AL CATALOGO",-1);return -2; }
			ctaltadq=0;posinc=regsxadq;
		 }
	 else
		{
		 if(ejemplar.existencia>0 || (regs>0 && regsxadq==0)) { mensadqui(abcp,CF);settextstyle(0,0,0);mensmoment(405,"ERROR: ARCHIVO DE ADQUISICIONES NO EXISTE",-1);return -3; }
		 ctaltadq=posinc=0;
		}
	else for(ctaltadq=pos;nrcia<ejemplar.existencia && nrcia<NRP;nrcia+=1) fread(&vadq[nrcia],sizeof(vadq[nrcia]),1,fad);
	opc.ch[1]=72;adq=eje=ne=fe=fs=pos=vtcal=cont=pginc=0;
	size=sizeof(ndx)+2*sizeof(adqui);
	do{
		 settextstyle(2,0,4);
		 if(rpg==1) //Recuenta pg. cuando hay altas,bajas o cambios
			{
			 if(ejemplar.existencia>0)
				{
				 numpg=ejemplar.existencia/NRP;if((ejemplar.existencia%NRP)==0) numpg-=1;
				 borrarecadq();mostrar(nrcia,vadq);
				}
			 else numpg=0;
			 if(abcp==-2) { settextstyle(0,0,0);return 0; }rpg=0;
			}
		 do{
				if(ejemplar.existencia>0 && (opc.ch[1]==72 || opc.ch[1]==80)) { setcolor(11);mostrar2(vtcal,vadq); } //Resalta seleccin
				opc.c=obtentecla();
				if(ejemplar.existencia>0 && (opc.ch[1]==72 || opc.ch[1]==80))
				 {
					setcolor(2);mostrar2(vtcal,vadq); //Quita resalto
					switch(opc.ch[1])
					 {
						case 72:
						 if(vtcal>0) { cont-=1;vtcal-=1; }
						 else
							if(pginc>0)
							 {
								fseek(fad,sizeof(adqui)*NRP*(pginc-1),0);
								for(nrcia=0;nrcia<NRP;nrcia+=1) fread(&vadq[nrcia],sizeof(vadq[nrcia]),1,fad);
								pginc-=1;cont-=1;vtcal=NRP-1;borrarecadq();mostrar(nrcia,vadq);
							 }break;
						case 80:
						 if(vtcal<NRP-1 && cont<ejemplar.existencia-1) { cont+=1;vtcal+=1; }
						 else
							if(vtcal>=NRP-1 && cont<ejemplar.existencia-1)
							 {
								pginc+=1;cont+=1;vtcal=0;
								fseek(fad,cont*sizeof(adqui),0);
								for(nrcia=0;nrcia<ejemplar.existencia-pginc*NRP && nrcia<NRP;nrcia+=1) fread(&vadq[nrcia],sizeof(vadq[nrcia]),1,fad);
								borrarecadq();mostrar(nrcia,vadq);
							 }
					 }
				 }
			 }while(opc.ch[1]==72 || opc.ch[1]==80);
		 if(abcp==2 && opc.c==7680) break; //Prstamo:Alt-A (Atrs)
		 if(opc.ch[1]==28 || opc.ch[1]==60 || opc.ch[1]==61) //Agregar/Modificar/Borrar/Marcar extraviado
			if(abcp==0 || abcp==1)
			 {
				if((opc.ch[1]==28 || opc.ch[1]==61) && ejemplar.existencia>0)
				 {
					itoa(vadq[vtcal].numejemp,numeje,10);strcpy(numadq,vadq[vtcal].numadqui);strcpy(numenv,vadq[vtcal].numenvio);
					strcpy(fechent,vadq[vtcal].fent);strcpy(fechsal,vadq[vtcal].fsal);
					if(opc.ch[1]==28)
					 {
						setcolor(9);outtextxy(294,224,numeje);outtextxy(330,224,numadq);outtextxy(390,224,numenv);
						outtextxy(456,224,fechent);outtextxy(534,224,fechsal);pos=0;
					 }
					else
					 if(vadq[vtcal].prestado!='P') { vadq[vtcal].prestado=(vadq[vtcal].prestado==' ') ? 'E' : ' ';pos=2; } //El extravo o deterioro de un ejemplar no decrementa la existencia
					 else { mensadqui(abcp,CF);settextstyle(0,0,0);mensmoment(405," REALICE PRIMERO LA DEVOLUCION DEL EJEMPLAR !",-1);mensadqui(abcp,15);continue; }
				 }
				else //Agregar (F2  ENTER con existencia cero)
				 {
					if(espacioendisco(sizedisk,unidad)<=size) { mensadqui(abcp,CF);settextstyle(0,0,0);mensmoment(405," ESPACIO INSUFICIENTE EN DISCO PARA AGREGAR ADQUISICIONES !",2);mensadqui(abcp,15);continue; }
					pos=1;numeje[0]=numadq[0]=numenv[0]=fechent[0]=fechsal[0]='\0';
				 }
				if(pos!=2)
				 {
					for(strcpy(ndx.atet,numeje);opc.ch[1]!=1 && opc.ch[1]!=31 && eje==0;)
					 {
						leekb41(294,224,numeje,2,9,'E',strlen(numeje),&opc);
						if(opc.ch[1]==1) { eje=0;break; }
						if(strlen(numeje)>0 && atoi(numeje)>0)
						 if(strcmp(numeje,ndx.atet)!=0)
							if((ftmp=fopen(SCBTMP[1],"rb"))!=NULL)
							 {
								for(eje=0;eje<ejemplar.existencia;eje+=1) //Busca secuencialmente en temporal que no se repita nm. ejemp.
								 {
									fread(&adqui,sizeof(adqui),1,ftmp);
									if(atoi(numeje)==adqui.numejemp) { mensadqui(abcp,CF);settextstyle(0,0,0);mensmoment(405,"EL NUMERO DE EJEMPLAR YA EXISTE",2);mensadqui(abcp,15);break; }
								 }fclose(ftmp);
								eje=(eje==ejemplar.existencia) ? 1 : 0; //No se repite nm ejemplar si cumple condicin
							 }
							else eje=1; //An no se ha creado archivo
						 else break; //ENTER (mismo dato,pasa a lectura sig.)
						else
						 if(strlen(ndx.atet)>0) //Borr dato
							{
							 desidebaja(abcp);
							 if(opc.ch[1]==31) eje=adq=ne=1;
							 else itoa(vadq[vtcal].numejemp,numeje,10); //Vuelve a poner dato
							} //No sale si:ENTER sin escribir,anulo baja o existe num. de ejemp.
					 }
					for(strcpy(ndx.atet,numadq);opc.ch[1]!=1 && opc.ch[1]!=31 && adq==0;)
					 {
						leekb41(330,224,numadq,6,9,'E',strlen(numadq),&opc);
						if(opc.ch[1]==1) { eje=0;break; }
						if(strlen(numadq)>0 && atol(numadq)>0) //Si son ceros=ningn caracter
						 if(strcmp(numadq,ndx.atet)!=0)
							{
							 if((fdx=fopen(ADQNDX,"rb"))!=NULL)
								if(buscax(fdx,regsxadq,numadq,0)>=0) //Busca coincidencia en ndice principal
								 { mensadqui(abcp,CF);settextstyle(0,0,0);mensmoment(405,"EL NUMERO DE ADQUISICION YA EXISTE",2);mensadqui(abcp,15);fclose(fdx);continue; }
								else fclose(fdx); //Adq. no se repite en ndice principal
							 if((fdx=fopen(SCBTMP[2],"rb"))!=NULL)
								if(buscax(fdx,ejemplar.existencia,numadq,0)>=0) //Busca coincidencia en ndice temporal
								 { mensadqui(abcp,CF);settextstyle(0,0,0);mensmoment(405,"EL NUMERO DE ADQUISICION YA EXISTE",2);mensadqui(abcp,15);fclose(fdx); }
								else { fclose(fdx);adq=1; } //Adq. no se repite en ndice temporal de altas
							 else adq=1;
							}
						 else break;
						else
						 if(strlen(ndx.atet)>0)
							{
							 desidebaja(abcp);
							 if(opc.ch[1]==31) eje=adq=ne=1;
							 else strcpy(numadq,vadq[vtcal].numadqui);
							}
					 }
					while(opc.ch[1]!=1 && opc.ch[1]!=31)
					 {
						leekb41(390,224,numenv,8,9,'A',strlen(numenv),&opc);
						if(opc.ch[1]==1) eje=adq=0; //Cancela nuevo o cambios
						else if(strcmp(numenv,vadq[vtcal].numenvio)!=0) ne=1;break;
					 }
					for(strcpy(ndx.atet,fechent);opc.ch[1]!=1 && opc.ch[1]!=31 && fe==0;)
					 {
						leekb41(456,224,fechent,10,9,'A',strlen(fechent),&opc);
						if(opc.ch[1]==1) { eje=adq=ne=0;break; } //Cancela nuevo o cambios
						if(strlen(fechent)>0)
						 if(strcmp(fechent,ndx.atet)!=0)
							{ mensadqui(abcp,CF);settextstyle(0,0,0);if(checafecha(fechent,3)!=0) fe=1;mensadqui(abcp,15); }
						 else break;
						else
						 if(strlen(ndx.atet)>0)
							{
							 desidebaja(abcp);
							 if(opc.ch[1]==31) eje=adq=ne=fe=fs=1;
							 else strcpy(fechent,ndx.atet);
							}
					 }
					for(strcpy(ndx.atet,fechsal);opc.ch[1]!=1 && opc.ch[1]!=31 && fs==0;)
					 {
						leekb41(534,224,fechsal,10,9,'A',strlen(fechsal),&opc);
						if(opc.ch[1]==1) { eje=adq=ne=fe=0;break; } //Cancela nuevo o cambios
						if(strlen(fechsal)>0)
						 if(strcmp(fechsal,ndx.atet)!=0)
							{ mensadqui(abcp,CF);setcolor(7);outtextxy(534,224,fechsal);settextstyle(0,0,0);if(checafecha(fechsal,3)!=0 && cmpfeches(fechsal,fechent,0)==1) { vadq[vtcal].prestado='S';fs=1; }mensadqui(abcp,15); }
						 else break;
						else
						 if(strlen(ndx.atet)>0)
							{
							 desidebaja(abcp);
							 if(opc.ch[1]==31) eje=adq=ne=fe=fs=1;
							 else { vadq[vtcal].prestado=' ';fs=1;mensadqui(abcp,CF);settextstyle(0,0,0);mensmoment(405,"SE REINCORPORA NUEVAMENTE EL EJEMPLAR",2);mensadqui(abcp,15); }
							}
						 else break; //No necesaria,pero si la tiene hay que darsela
					 }
				 }
				if(opc.ch[1]!=1 && (opc.ch[1]==31 || eje==1 || adq==1 || ne==1 || fe==1 || fs==1 || pos==2))
				 {
					borrarecadq();setcolor(getpixel(401,188));settextstyle(0,0,0);outtextxy(403,190,itoa(ejemplar.existencia,aux,10));settextstyle(2,0,4);
					if(pos==0 || pos==2) //Modific o baja de adquisicin
					 {
						fclose(fad); //Cierra SCBTMP[1] para poder apuntar al maestro
						if((fad=fopen(BDADQ,"rb+"))!=NULL && posinc<regsxadq) //Por lo de ttulo nuevo ya existiendo el maestro
						 {
							fseek(fad,posinc*sizeof(adqui),0);adq=0; //Se posiciona en el primer ejemplar del ttulo para baja o modif.
							do{fread(&adqui,sizeof(adqui),1,fad);adq+=1; //Localiza en maestro por adq. al que se modif. o elimina
								}while(strcmp(adqui.numadqui,vadq[vtcal].numadqui)!=0 && adqui.posicion==ndx.posicion && adq<=ejemplar.existencia-ctaltadq);
							if(opc.ch[1]==31) //Elimina adquisicin de maestro
							 {
								if(adq<=ejemplar.existencia-ctaltadq) //Est en maestro por ser adq. existente
								 {
									regsxadq=recorradq(fad,BDADQ,regsxadq,adq-1+posinc);
									pos=ndx.posicion;auxcreaindex(0);ndx.posicion=pos; //Vuelve a crear ndice principal por adq. y no perder la posicin del ttulo en el catlogo
								 }
							 }
							else //Guarda cambios en maestro
							 if(adq<=ejemplar.existencia-ctaltadq) //Slo si ya existe en maestro
								if(pos==2) { fseek(fad,(adq-1+posinc)*sizeof(adqui),0);fwrite(&vadq[vtcal],sizeof(vadq[vtcal]),1,fad); }
								else
								 if(vadq[vtcal].numejemp!=atoi(numeje) || strcmp(vadq[vtcal].numadqui,numadq)!=0 || strcmp(vadq[vtcal].numenvio,numenv)!=0
										|| strcmp(vadq[vtcal].fent,fechent)!=0 || strcmp(vadq[vtcal].fsal,fechsal)!=0)
									{
									 adqui.posicion=vadq[vtcal].posicion;adqui.numejemp=atoi(numeje);strcpy(adqui.numadqui,numadq);strcpy(adqui.numenvio,numenv);
									 strcpy(adqui.fent,fechent);strcpy(adqui.fsal,fechsal);adqui.prestado=vadq[vtcal].prestado;
									 fseek(fad,(adq-1+posinc)*sizeof(adqui),0);fwrite(&adqui,sizeof(adqui),1,fad);
									 if(vadq[vtcal].numejemp!=atoi(numeje)) inseradq(fad,regsxadq,regsxadq-(adq-1+posinc));
									 if(strcmp(vadq[vtcal].numadqui,numadq)!=0) { pos=ndx.posicion;auxcreaindex(0);ndx.posicion=pos; }
									}fclose(fad);
						 }fad=fopen(SCBTMP[1],"rb+"); //Dado que apuntaba al maestro
						if(opc.ch[1]==31) //Elimina de temporales
						 {
							ejemplar.existencia=recorradq(fad,SCBTMP[1],ejemplar.existencia,cont);
							if(ctaltadq>0)
							 if((fdx=fopen(SCBTMP[2],"rb+"))!=NULL)
								{
								 if(buscax(fdx,ctaltadq,vadq[vtcal].numadqui,0)>=0)
									{
									 adq=buscax(fdx,ctaltadq,vadq[vtcal].numadqui,1);
									 ctaltadq=recorrx(fdx,SCBTMP[2],ctaltadq,adq);
									}fclose(fdx);
								}
						 }
						else //Guarda cambios en temporales
						 if(pos==2) { fseek(fad,cont*sizeof(adqui),0);fwrite(&vadq[vtcal],sizeof(vadq[vtcal]),1,fad); }
						 else
							if(vadq[vtcal].numejemp!=atoi(numeje) || strcmp(vadq[vtcal].numadqui,numadq)!=0 || strcmp(vadq[vtcal].numenvio,numenv)!=0
								 || strcmp(vadq[vtcal].fent,fechent)!=0 || strcmp(vadq[vtcal].fsal,fechsal)!=0)
							 {
								adqui.posicion=vadq[vtcal].posicion;adqui.numejemp=atoi(numeje);strcpy(adqui.numadqui,numadq);strcpy(adqui.numenvio,numenv);
								strcpy(adqui.fent,fechent);strcpy(adqui.fsal,fechsal);adqui.prestado=vadq[vtcal].prestado;
								fseek(fad,cont*sizeof(adqui),0);fwrite(&adqui,sizeof(adqui),1,fad);
								if(vadq[vtcal].numejemp!=atoi(numeje)) inseradq(fad,ejemplar.existencia,ejemplar.existencia-cont);
							 }
						 if(ctaltadq>0 && strcmp(vadq[vtcal].numadqui,numadq)!=0)
							if((fdx=fopen(SCBTMP[2],"rb+"))!=NULL)
							 {
								if(buscax(fdx,ctaltadq,vadq[vtcal].numadqui,0)>=0)
								 {
									adq=buscax(fdx,ctaltadq,vadq[vtcal].numadqui,1);
									strcpy(ndx.atet,numadq);
									fseek(fdx,adq*sizeof(ndx),0);fwrite(&ndx,sizeof(ndx),1,fdx);
									reindexa(fdx,ctaltadq,adq);
								 }fclose(fdx);
							 }
					 }
					else
					 if(pos==1) //Agreg adquisicin
						{
						 pos=adqui.posicion=ndx.posicion;adqui.numejemp=atoi(numeje);strcpy(adqui.numadqui,numadq);strcpy(adqui.numenvio,numenv);
						 strcpy(adqui.fent,fechent);strcpy(adqui.fsal,fechsal);adqui.prestado=' ';
						 if(fopen(SCBTMP[1],"rb")==NULL) fad=fopen(SCBTMP[1],"wb+");
						 fseek(fad,ejemplar.existencia*sizeof(adqui),0);fwrite(&adqui,sizeof(adqui),1,fad);inseradq(fad,ejemplar.existencia+1,1);
						 ndx.posicion=regsxadq;strcpy(ndx.atet,numadq); //No es necesario guardar posicin en temporal ndice ya que es desechado y se llama a auxcreaindex()
						 if((fdx=fopen(SCBTMP[2],"rb+"))==NULL) fdx=fopen(SCBTMP[2],"wb+");
						 fseek(fdx,ctaltadq*sizeof(ndx),0);fwrite(&ndx,sizeof(ndx),1,fdx);/*putchar(7);*/insercion(fdx,ctaltadq+1,1);fclose(fdx);
						 ejemplar.existencia+=1;ctaltadq+=1;ndx.posicion=pos; //No perder posicin del ttulo en el catlogo
						}
					if(opc.ch[1]!=61)
					 {
						for(rewind(fad),nrcia=0;nrcia<ejemplar.existencia && nrcia<NRP;nrcia+=1) fread(&vadq[nrcia],sizeof(vadq[nrcia]),1,fad);
						mdfadq=rpg=1;adq=eje=ne=fe=fs=pos=vtcal=cont=pginc=0;
						setcolor(1);settextstyle(0,0,0);outtextxy(403,190,itoa(ejemplar.existencia,aux,10));
					 }
					else mostrar(nrcia,vadq);
				 }opc.ch[1]=72; //Evita salir de abcpadqui() cuando se da ESC en edicin y permitir resalto
			 }
			else
			 {
				mensadqui(abcp,CF);settextstyle(0,0,0);
				switch(vadq[vtcal].prestado)
				 {
					case ' ':ne=vadq[vtcal].numejemp;strcpy(nq,vadq[vtcal].numadqui);break; //Prstamo
					case 'P':mensmoment(405," EL EJEMPLAR ESTA EN PRESTAMO !",2);break;
					case 'E':mensmoment(405," EJEMPLAR EXTRAVIADO !",2);break;
					case 'S':mensmoment(405," EJEMPLAR NO DISPONIBLE !",2);
				 }mensadqui(abcp,15);
			 }
		 else break; //Ver ms
		 recuadro(291,224,3,2,1);recuadro(327,224,7,2,1);recuadro(387,224,8,2,1);recuadro(453,224,10,2,1);recuadro(531,224,10,2,1);
		}while(opc.ch[1]!=1 && opc.c!=7680);
	fclose(fad);pos=ctaltadq;mensadqui(abcp,CF);settextstyle(0,0,0);return mdfadq;
 }

void borrarecadq(void) { setfillstyle(0,CF);floodfill(292,242,14); }

long buscadq(FILE *f,long nr,long dato,int bus)
 {
	long ini=0,fin=nr,med=fin/2;
	struct adqdat x;
	if(nr<=0) return -3;
	while(1)
	 {
		fseek(f,med*sizeof(x),0);fread(&x,sizeof(x),1,f);
		if(dato<x.posicion) { fin=med;med=(med-ini)/2+ini;if(fin==med) break; }
		else if(dato>x.posicion) { ini=med;med=(fin-med)/2+med;if(ini==med) break;	}
				 else break;
	 }
	if(dato==x.posicion) //Encontrado
	 while(1) //Buscar el primero
		{
		 if(med>0) med-=1;else return med;
		 fseek(f,med*sizeof(x),0);fread(&x,sizeof(x),1,f);
		 if(dato!=x.posicion) { med+=1;return med; }
		}
	else if(bus==0) return -2;
			 else if(dato>x.posicion) return med+1;
						else return med-1;
 }

void altbajadq(int va)
 {
	if((fad=fopen(BDADQ,"rb+"))==NULL) fad=fopen(BDADQ,"wb+");
	if(BKADQ[0]!='@') if((ftmp=fopen(BKADQ,"rb+"))==NULL) ftmp=fopen(BKADQ,"wb+");
	if(va==1) //No se hace en agregar ttulo dado que no existe an la posicin en maesto
	 {
		if(BKADQ[0]!='@') recorrposadq(ftmp,BKADQ,regsxadq); //Los quita adq. del backup (si existe) y
		regsxadq=recorrposadq(fad,BDADQ,regsxadq); //del maestro
	 }
	if((ftmp2=fopen(SCBTMP[1],"rb"))!=NULL)
	 {
		fseek(fad,regsxadq*sizeof(adqui),0); //Se coloca en fin de archivo del maestro y
		if(BKADQ[0]!='@') fseek(ftmp,regsxadq*sizeof(adqui),0); //del backup (si existe)
		for(subcarp=0;subcarp<ejemplar.existencia;regsxadq+=1,subcarp+=1) //Se incorporan adq. anteriores y nuevas del archivo temporal a maestro y backup (si existe)
		 {
			fread(&adqui,sizeof(adqui),1,ftmp2);fwrite(&adqui,sizeof(adqui),1,fad);
			if(BKADQ[0]!='@') fwrite(&adqui,sizeof(adqui),1,ftmp);
		 }fclose(ftmp2);remove(SCBTMP[1]);remove(SCBTMP[2]);
		if(BKADQ[0]!='@') { inseradq(ftmp,regsxadq,subcarp);fclose(ftmp); }
		inseradq(fad,regsxadq,subcarp);fseek(fad,0,0);
	 }
	auxcreaindex(0);fclose(fad); //Crea ndice primario por adq.
 }

void mostrar(int nrcia,struct adqdat vadq[])
 {
	int d=0;
	for(setcolor(2);d<nrcia && d<NRP;d+=1) mostrar2(d,vadq);
 }

void mostrar2(int v,struct adqdat vadq[])
 {
	outtextxy(294,245+v*16,itoa(vadq[v].numejemp,aux,10));
	outtextxy(330,245+v*16,vadq[v].numadqui);
	outtextxy(390,245+v*16,vadq[v].numenvio);
	outtextxy(456,245+v*16,vadq[v].fent);
	outtextxy(534,245+v*16,vadq[v].fsal);
	aux[0]=(vadq[v].prestado=='P') ? '' : (vadq[v].prestado=='E') ? '*': (vadq[v].prestado=='S') ? '-': ' ';
	aux[1]='\0';outtextxy(599,245+v*16,aux);
 }

void mensadqui(int abcp,int om)
 {
	settextstyle(0,0,0);mensajes(405," , :Ver ms y selecionar nm. ejemplar",om);
	switch(abcp) //Viene de
	 {
		case -1:mensajes(390,"Cualquier otra tecla para salir",om);break; //Catlogo-Ver ms
		case  0: //Catlogo-Agregar
		case  1:mensajes(390,"ENTER:Editar/Aceptar  F2:Agregar  F3:Extraviado  ESC:Salir/Cancelar",om);break; //Catlogo-Modificar
		case  2:mensajes(390,"ENTER:Aceptar  Alt-A:Atrs  ESC:Cancelar",om); //Prstamo
	 }if(abcp<3) flechasupdw(0);settextstyle(2,0,4);
 }

void desidebaja(int abcp)
 {
	mensadqui(abcp,CF);settextstyle(0,0,0);mensajes(405,"Desea dar de baja el ejemplar (S/N):",15);
	do{ opc.c=obtentecla(); }while(opc.ch[1]!=1 && opc.ch[1]!=31 && opc.ch[1]!=49);
	mensajes(405,"Desea dar de baja el ejemplar (S/N):",CF);mensadqui(abcp,15);
 }

long recorradq(FILE *f,char *FUENTE,long nr,long lugar)
 {
	long i=0,j=0;
	FILE *ima;
	ima=fopen("~SMRK.TMP","wb");
	for(fseek(f,0,0);i<nr;i+=1)
	 {
		fread(&adqui,sizeof(adqui),1,f);
		if(i!=lugar) { fwrite(&adqui,sizeof(adqui),1,ima);j+=1; }
	 }
	fclose(ima);fclose(f);
	remove(FUENTE);rename("~SMRK.TMP",FUENTE);
	f=fopen(FUENTE,"rb+");
	return j;
 }

long recorrposadq(FILE *f,char *FUENTE,long nr)
 {
	FILE *ima;
	long i=0,j=0;
	ima=fopen("~MRK.TMP","wb");
	for(fseek(f,0,0);i<nr;i+=1)
	 {
		fread(&adqui,sizeof(adqui),1,f);
		if(adqui.posicion!=ndx.posicion) { fwrite(&adqui,sizeof(adqui),1,ima);j+=1; }
	 }
	fclose(ima);fclose(f);
	remove(FUENTE);rename("~MRK.TMP",FUENTE);
	f=fopen(FUENTE,"rb+");
	return(j);
 }

long inseradq(FILE *f,long nr,long rins)
 {
	struct adqdat nuevo,actual;
	long oldregs,ubi,recorre,ini,fin;
	if(nr<2) return nr;
	if(rins>nr) return -2;
	for(oldregs=nr-rins;oldregs<nr;oldregs+=1)
	 {
		fseek(f,oldregs*sizeof(nuevo),0);fread(&nuevo,sizeof(nuevo),1,f);
		ini=0;fin=oldregs;ubi=fin/2;
		while(1)
		 {
			fseek(f,ubi*sizeof(actual),0);fread(&actual,sizeof(actual),1,f);
			if(nuevo.posicion<actual.posicion) { fin=ubi;ubi=(ubi-ini)/2+ini;if(fin==ubi) break; }
			else if(nuevo.posicion>actual.posicion) { ini=ubi;ubi=(fin-ubi)/2+ubi;if(ini==ubi) break;	}
					 else if(nuevo.numejemp<actual.numejemp) { fin=ubi;ubi=(ubi-ini)/2+ini;if(fin==ubi) break; }
								else if(nuevo.numejemp>actual.numejemp) { ini=ubi;ubi=(fin-ubi)/2+ubi;if(ini==ubi) break;	}
										 else break;
		 }
		if(ubi==0)
		 {
			fseek(f,0,0);fread(&actual,sizeof(actual),1,f);
			if(actual.posicion<=nuevo.posicion && actual.numejemp<nuevo.numejemp) ubi+=1;
		 }
		else ubi+=1;
		for(recorre=oldregs-1;recorre>=ubi;recorre-=1)
		 {
			fseek(f,recorre*sizeof(actual),0);fread(&actual,sizeof(actual),1,f);
			fseek(f,(recorre+1)*sizeof(actual),0);fwrite(&actual,sizeof(actual),1,f);
		 }
		fseek(f,ubi*sizeof(nuevo),0);fwrite(&nuevo,sizeof(nuevo),1,f);
	 }
	return oldregs;
 }



/*JSoft Corporation. (C) Reservados todos los derechos 2002*/