/*Programa: SCB.CPP
	Proceso: Visualiza carpeta principal y realiza llamadas a todas las funciones*/

#include "fvarscb.cpp"
#include "fdatdisk.cpp"
#include "fctrkb41.cpp"
#include "fundscb.cpp"
#include "fadqui.cpp"
#include "floghlp.cpp"
#include "fimprim.cpp"
#include "fbibscb.cpp"
#include "fundbib.cpp"

void main(void)
 {
	int m=0,d;           //d:Cuenta caracteres para contrasea y otros
	char uni[]={"ABCDEFGHIJKLMNOPQRSTUVWXYZ"};
	int pase=0;          //1:acceso a carpetas inferiores;0:no acceso
	int x,y;             //Coordenadas de pestaas de carpetas
	int auxnl,auxen,en;  //Control de visualizacin de ayuda
	int leeocuayu,carpini; //Lee u oculta ayuda,control carpetas iniciales
	initgraph(&m,&d,"");
	switch(m)
	 {
		case  1:
		case  3:
		case  4:
		case  5:
		case  7:
		case 10: /*CGA,EGA,EGA64,EGAMONO,PC3270*/
		 closegraph();clrscr();gotoxy(13,11);
		 printf("EL TIPO DE MONITOR NO ES EL ADECUADO PARA EL PROGRAMA");
		 obtentecla();clrscr();exit(1);
		case  2:
		case  8:d=5;break; /*MCGA,ATT400*/
		case  6:d=0;break; /*IBM8514*/
		case  9:d=2;break; /*VGA*/
		default:m=9;d=2;   /*DESCONOCIDO.Por default sera:640x480*/
	 }
	initgraph(&m,&d,"");cleardevice();setbkcolor(CF);
	setcolor(4);rectangle(0,0,639,479);rectangle(2,2,637,477); //Marco
	setcolor(15);settextstyle(7,0,2);strcpy(titcarp,"Sistema de Consulta Bibliogrfica");
	outtextxy((640-textwidth(titcarp))/2,25,titcarp);
	setcolor(15);rectangle(20,110,619,419);rectangle(22,112,617,417);	//Carpeta
	rutaexe[0]=uni[getdisk()];rutaexe[1]='\0'; //Pone letra de unidad
	strncat(rutaexe,":\\",2);
	getcurdir(0,diractual); //Lee ruta actual (sin unidad)
	if(strlen(diractual)>0) { strcat(rutaexe,diractual);strcat(rutaexe,"\\"); } //Enlaza con ruta actual
	if((ftmp=fopen("CONFIG.SCB","rb"))==NULL) //Configuracin por default
	 {
		opconf.impresora=0;
		strcpy(opconf.ruta,rutaexe);
		opconf.dpad=2;
		for(d=0;d<7;d+=1) opconf.dd[d]='0';
		opconf.aar='0';opconf.logo='1';
		strcpy(opconf.nombre,"Plantel 19 \"Ecatepec\"");
		strcpy(opconf.clave,"JSoft");
	 }
	else
	 {
		fread(&opconf,sizeof(opconf),1,ftmp);
		if(analizaruta(opconf.ruta)!=0) strcpy(opconf.ruta,rutaexe); //Si hay problemas en ruta leida copia ruta donde se ejecut programa
		fclose(ftmp);
	 }
	iniruta();strcat(rutaexe,"CONFIG.SCB");
	setcolor((opconf.logo=='1') ? 2 : CF);logoCB();
	setcolor(2);settextstyle(6,0,1);outtextxy((640-textwidth(opconf.nombre))/2,1,opconf.nombre);
	subcarp=nl=leeocuayu=carpini=pase=d=0;fechoy[0]='\0';
	do{ //Si subcarp=0 inicia o se est saliendo de funcin
		 if(subcarp==0 || push.c==0 || push.ch[1]==1 || push.ch[1]==75 || push.ch[1]==77)
			{
			 if(subcarp==0) { cejassupynom(7,11);subcarp=1; }
			 (pase==0) ? cejasinfynom(8,8) : cejasinfynom(7,11);
			 switch(carpini)
				{
				 case  0:strcpy(titcarp,"CATALOGO DE LIBROS");x=20;y=85;break;
				 case  1:strcpy(titcarp,"CATALOGO DE REVISTAS");x=101;y=85;break;
				 case  2:strcpy(titcarp,"CATALOGO DE PERIODICOS");x=182;y=85;break;
				 case  3:strcpy(titcarp,"CATALOGO DE FOLLETOS");x=263;y=85;break;
				 case  4:strcpy(titcarp,"CATALOGO DE FASCICULOS");x=344;y=85;break;
				 case  5:strcpy(titcarp,"CATALOGO VARIOS");x=425;y=85;break;
				 case  6:strcpy(titcarp,"ACERCA DE ...");x=506;y=85;break;
				 case  7:strcpy(titcarp,"OPCIONES");x=458;y=420;break;
				 case  8:strcpy(titcarp,"SALIR DEL SISTEMA");x=539;y=420;
				}
			 setcolor(14);settextstyle(0,0,0);outtextxy(30,160,titcarp);
			 setcolor(11);rectangle(x+1,y+1,x+79,y+23);setcolor(15);rectangle(x,y,x+80,y+24);
			 if(leeocuayu==0 || carpini>5)
				{
				 asignatex(carpini);auxnl=auxen=en=0;leeocuayu=1;
				 if(nl==0) { settextstyle(1,0,1);mensajes(250,"NO HAY AYUDA PARA ESTA CARPETA",10); }
				 else ponayu(auxen,7); //Visualiza primeras LA lineas de ayuda
				 if(subcarp!=-1) { mensabc(0,10);subcarp=-1; }
				}
			}leeocuayu=carpini;
		 while(1) //Valida lo pulsado
			{
			 push.c=obtentecla();
			 if(push.ch[1]!= 1 && push.ch[1]!=28 && push.ch[1]!=75 &&	push.ch[1]!=77 &&
					push.ch[1]!=72 && push.ch[1]!=73 && push.ch[1]!=80 && push.ch[1]!=81)
				{
				 switch(push.c) //Alt+letra subrayada/Alfanumrica
					{
					 case 12288:if(carpini!=0) carpini=0;else continue;push.c=0;break;
					 case  4864:if(carpini!=1) carpini=1;else continue;push.c=0;break;
					 case  6400:if(carpini!=2) carpini=2;else continue;push.c=0;break;
					 case  9728:if(carpini!=3) carpini=3;else continue;push.c=0;break;
					 case  8448:if(carpini!=4) carpini=4;else continue;push.c=0;break;
					 case 12032:if(carpini!=5) carpini=5;else continue;push.c=0;break;
					 case  7680:if(carpini!=6) carpini=6;else continue;push.c=0;break;
					 case  6144:if(pase==1 && carpini!=7) carpini=7;else continue;push.c=0;break;
					 case  7936:if(pase==1 && carpini!= 8) carpini= 8;else continue;push.c=0;break;
					 default   :if(isgraph(push.ch[0])==0 && push.ch[0]!=' ') continue;
					}break; //Sale de ciclo cuando es atajo o tecla alfanumrica
				}
			 else if(push.ch[1]==1 && strcmp(acceso,opconf.clave)!=0) continue;break; //Sale de ciclo si la tecla es correcta
			}
		 if(push.c==0 || push.ch[1]==1 || push.ch[1]==28 || push.ch[1]==75 || push.ch[1]==77)
			{
			 setcolor(CF);settextstyle(0,0,0);outtextxy(30,160,titcarp); //Restaura pestaa
			 rectangle(x+1,y+1,x+79,y+23);setcolor(7);rectangle(x,y,x+80,y+24);
			 if((push.ch[1]==1 && pase==1) || leeocuayu>5 || (carpini>5 && leeocuayu<6)) { ponayu(auxen,CF);leeocuayu=0; }
			 else leeocuayu=1;
			}
		 if(push.c==0) continue;
		 switch(push.ch[1])
			{
			 case 72:
			 case 73:
				if(nl>LA && auxnl>0)
				 {
					if(push.ch[1]==72) { auxnl-=1;en-=1; }
					else if((auxnl-LA)<0) { en-=auxnl;auxnl=0; }else { en-=LA;auxnl-=LA; }
					ponayu(auxen,CF);ponayu(en,7);auxen=en; //Borra y presenta ms ayuda
				 }d=0;break;
			 case 80:
			 case 81:
				if(nl>=LA)
				 if(auxnl<(nl-LA))
					{
					 if(push.ch[1]==80) { auxnl+=1;en+=1; }
					 else if((auxnl+32)>nl) { en+=(nl-LA-auxnl);auxnl=nl-LA; }else { en+=LA;auxnl+=LA; }
					 ponayu(auxen,CF);ponayu(en,7);auxen=en;
					}d=0;break;
			 case 75:carpini=(carpini>0) ? carpini-1 : (pase==0) ? 6 : 8;
				d=0;if(carpini>5 && carpini<9) { ponayu(auxen,CF);leeocuayu=0; }break;
			 case 77:
				if(pase==0) carpini=(carpini<6) ? carpini+1 : 0;
				else carpini=(carpini<8) ? carpini+1 : 0;
				d=0;if(carpini>5 && carpini<8) { ponayu(auxen,CF);leeocuayu=0; }break;
			 case 28:
				if(carpini==8) carpini=-1; //Para salir del programa
				else
				 {
					borralins();setcolor(CF);rectangle(x+1,y+1,x+79,y+23); //Borra pestaa interna
					cejassupynom(CF,CF);cejasinfynom(CF,CF);
					carp=(carpini<6) ? carpini : -1; //-1:No es carpeta que haga referencia a un catlogo
					switch(carpini)
					 {
						case 0:
						case 1:
						case 2:
						case 3:
						case 4:
						case 5:abcbib(pase);break;
						case 6:jsoftc();break;
						case 7:fopcio();
					 }subcarp=leeocuayu=d=pos=0; //Para visualizar carpetas de inicio
				 }break;
			 case  1: //Activa/desactiva pestaas inf. con ESC
			 default:
				if(pase==0)
				 if(isalnum(push.ch[0])!=0 || isspace(push.ch[0])!=0)
					{
					 if(d<AC) { acceso[d]=push.ch[0];d+=1;acceso[d]='\0'; }else d=0;
					 if(strcmp(acceso,opconf.clave)==0) { push.c=0;pase=1;leeocuayu=0; } //Activa pestaas
					}
				if(pase==1) if(push.ch[1]==1) { d=pase=push.c=0;acceso[0]='\0';carpini=(carpini>6) ? 0 : carpini; } //Desactiva pestaas
			}
		}while(carpini!=-1);
	closegraph();
 }

void iniruta()
 {
	int d;
	unsigned long espace;
	settextstyle(0,0,0);mensajes(405,"Verificando catlogos e ndices...",15);
	strncpy(unidad,opconf.ruta,3);unidad[3]='\0'; //Copia unidad de trabajo
	for(carpx=d=0;d<3;d+=1)
	 if((pos=leenomarch(fechoy,60+d))!=-1)
		{
		 strcpy(SCBTMP[d],opconf.ruta);strcat(SCBTMP[d],fechoy);
		 if(access(SCBTMP[d],0)==0) { remove(SCBTMP[d]);carpx=-2; } //Borra temporal y ordena crear todos los arch. ndices
		}
	for(carp=0;pos!=-1 && carp<7;carp+=1) //Copia ruta y nombres de arch.
	 {
		if((pos=leenomarch(fechoy,carp))==-1) break;strcpy(BD,opconf.ruta);strcat(BD,fechoy);
		if((pos=leenomarch(fechoy,7+carp))==-1) break;strcpy(BK,opconf.ruta);strcat(BK,fechoy);
		nx=(carp==0) ? 5 : (carp<6) ? 4 : 3; //Nm. de arch. ndices segn carpeta
		for(d=0;d<nx;d+=1) //Pone ruta y nombre de arch. ndice,excepto el de adq.
		 {
			pos=(carp==0) ? leenomarch(fechoy,26+d) : leenomarch(fechoy,27+5*carp+d);
			if(pos==-1) break;strcpy(IND[d],opconf.ruta);strcat(IND[d],fechoy);
		 }if(pos==-1) break;
		if(carp<6)
		 {
			if((pos=leenomarch(fechoy,14+carp))==-1) break;strcpy(BDADQ,opconf.ruta);strcat(BDADQ,fechoy);
			if((pos=leenomarch(fechoy,20+carp))==-1) break;strcpy(BKADQ,opconf.ruta);strcat(BKADQ,fechoy);
			pos=(carp==0) ? leenomarch(fechoy,31) : leenomarch(fechoy,31+5*carp);
			if(pos==-1) break;strcpy(ADQNDX,opconf.ruta);strcat(ADQNDX,fechoy);
		 }regs=0;
		if((fbd=fopen(BD,"rb"))!=NULL)
		 {
			regs=calcregs(BD,0);
			if(regs>0 && access(BK,0)!=0) //Crea backup
			 {
				for(ftmp=fopen(BK,"wb"),d=0;d<regs;d+=1)
				 {
					espace=espacioendisco(sizedisk,unidad); //Siempre dado que el programa no es el nico que accede al disco
					if((carp<6) ? espace>=sizeof(ejemplar) : espace>=sizeof(usuar)) //Ve si hay espacio en disco
					 if(carp<6) { fread(&ejemplar,sizeof(ejemplar),1,fbd);fwrite(&ejemplar,sizeof(ejemplar),1,ftmp); }
					 else { fread(&usuar,sizeof(usuar),1,fbd);fwrite(&usuar,sizeof(usuar),1,ftmp); }
					else { mensmoment(390," ESPACIO INSUFICIENTE EN DISCO PARA TERMINAR DE CREAR ARCHIVOS BACKUP !",2);break; }
				 }fclose(ftmp);if(d<regs) remove(BK);rewind(fbd);
			 }
		 }
		else
		 if(access(BK,0)==0) //Busca backup para crear maestro
			{
			 regs=calcregs(BK,0);
			 if(regs>0)
				{
				 for(ftmp=fopen(BK,"rb"),fbd=fopen(BD,"wb"),d=0;d<regs;d+=1) //Crea maestro
					{
					 espace=espacioendisco(sizedisk,unidad);
					 if((carp<6) ? espace>=sizeof(ejemplar) : espace>=sizeof(usuar))
						if(carp<6) { fread(&ejemplar,sizeof(ejemplar),1,ftmp);fwrite(&ejemplar,sizeof(ejemplar),1,fbd); }
						else { fread(&usuar,sizeof(usuar),1,ftmp);fwrite(&usuar,sizeof(usuar),1,fbd); }
					 else
						{
						 mensmoment(390," ESPACIO INSUFICIENTE EN DISCO PARA TERMINAR DE CREAR ARCHIVOS MAESTROS !",15);
						 mensmoment(390,"RENOMBRANDO RESPALDO COMO MAESTRO",2);espace=0;break;
						}
					}fclose(ftmp);fclose(fbd);if(espace==0) rename(BK,BD);fbd=fopen(BD,"rb");
				}
			}
		if(carp<6)
		 if((fad=fopen(BDADQ,"rb"))!=NULL)
			{
			 regsxadq=calcregs(BDADQ,1);
			 if(regsxadq>0 && access(BKADQ,0)!=0) //Crea backup
				{
				 for(ftmp=fopen(BKADQ,"wb"),d=0;d<regsxadq;d+=1)
					{
					 espace=espacioendisco(sizedisk,unidad);
					 if(espace>=sizeof(adqui)) { fread(&adqui,sizeof(adqui),1,fad);fwrite(&adqui,sizeof(adqui),1,ftmp); }
					 else { mensmoment(390," ESPACIO INSUFICIENTE EN DISCO PARA TERMINAR DE CREAR ARCHIVO RESPALDO !",2);break; }
					}fclose(ftmp);if(d<regsxadq) remove(BKADQ);rewind(fad);
				}
			}
		 else
			if(access(BKADQ,0)==0) //Busca respaldo para crear maestro
			 {
				regsxadq=calcregs(BKADQ,1);
				if(regsxadq>0)
				 {
					for(ftmp=fopen(BKADQ,"rb"),fad=fopen(BDADQ,"wb"),d=0;d<regsxadq;d+=1) //Crea maestro
					 {
						espace=espacioendisco(sizedisk,unidad);
						if(espace>=sizeof(adqui)) { fread(&adqui,sizeof(adqui),1,ftmp);fwrite(&adqui,sizeof(adqui),1,fad); }
						else
						 {
							mensmoment(390," ESPACIO INSUFICIENTE EN DISCO PARA TERMINAR DE CREAR ARCHIVO MAESTRO !",2);
							mensmoment(390,"RENOMBRANDO RESPALDO COMO MAESTRO",2);espace=0;break;
						 }
					 }fclose(ftmp);fclose(fad);if(espace==0) rename(BKADQ,BDADQ);fad=fopen(BDADQ,"rb");
				 }
			 }
		if(regs>0 && regsxadq>0)
		 {
			if(carpx!=-2)
			 {
				for(d=0;d<nx && carpx!=-1;d+=1) carpx=(access(IND[d],0)!=0 || calcregs(IND[d],2)==0) ? -1 : (!(d==3 && carp==0)) ? cmpregsmtryndx(IND[d]) : 0;
				if(carp<6 && carpx!=-1 && (access(ADQNDX,0)!=0 || calcregs(ADQNDX,2)==0)) carpx=-1;
			 }
			if(carpx==-1 || carpx==-2) //NO existe o tiene CERO algn indexado o se detect algn temporal
			 { auxcreaindex(1);if(carpx==-1) carpx=0; } //crea ndices y pone a 0 al tratndose de arch. ndice
		 }
		else //No existe maestro,est vaco o no es vlido,lo borra al igual que sus ndices si estn
		 {
			if(access(BD,0)==0) remove(BD);
			if(access(BK,0)==0) remove(BK);
			for(d=0;d<nx;d+=1) if(access(IND[d],0)==0) remove(IND[d]); //Revisa si existe indexado y lo borra
			if(carp<6)
			 {
				if(access(BDADQ,0)==0) remove(BDADQ);
				if(access(BKADQ,0)==0) remove(BKADQ);
				if(access(ADQNDX,0)==0) remove(ADQNDX); //No para carpeta usuario
			 }
		 }
	 }
	mensajes(405,"Verificando catlogos e ndices...",CF);
	if(pos==-1) { closegraph();exit(1); } //!Error!: necesita restaurar archivo de nombres o no corresponde algn catlogo
 }

int leenomarch(char nom[],int lin)
 {
	char n[11];strcpy(n,nom);
	do{
		 if((ftmp=fopen("NOMARCH.SCB","rb"))!=NULL) { fseek(ftmp,lin*sizeof(n),0);fread(&n,sizeof(n),1,ftmp);fclose(ftmp);strcpy(nom,n);break; }
		 else
			if(access("CREANOMB.EXE",0)==0) system("CREANOMB.EXE 1");
			else
			 {
				mensajes(375,"INSTALE NUEVAMENTE EL ARCHIVO DE CREACION DE NOMBRES",15);
				mensmoment(390,"ERROR!: FALTA ARCHIVO DE NOMBRES",-1);
				mensajes(375,"INSTALE NUEVAMENTE EL ARCHIVO DE CREACION DE NOMBRES",CF);
				lin=-1;break;
			 }
		}while(1);
	return lin;
 }

long calcregs(char ARCH[],int que)
 {
	if(findfirst(ARCH,&sizefile,0)==-1) return 0;
	switch(que)
	 {
		case 0:if(((carp<6) ? sizefile.ff_fsize%sizeof(ejemplar) : sizefile.ff_fsize%sizeof(usuar))==0) //Si no hay residuo es arch. vlido
						return (carp<6) ? sizefile.ff_fsize/sizeof(ejemplar) : sizefile.ff_fsize/sizeof(usuar); //Calcula registros: x maestro
		case 1:if(sizefile.ff_fsize%sizeof(adqui)==0) return sizefile.ff_fsize/sizeof(adqui); //x adquisicin
		case 2:if(sizefile.ff_fsize%sizeof(ndx)==0) return sizefile.ff_fsize/sizeof(ndx); //x materia u otro ndice
	 }
	mensmoment(390,"ERROR!: ARCHIVOS DE CATALOGOS NO CORRESPONDEN",-1);return 0;
 }

int cmpregsmtryndx(char str[]) //Devuelve:0,son iguales;-1,diferentes
 {
	findfirst(str,&sizefile,0);
	if(sizefile.ff_fsize%sizeof(ndx)==0)
	 if(regs==sizefile.ff_fsize/sizeof(ndx)) return 0;return -1;
 }

void cejassupynom(int clr,int clr2)
 {
	setcolor(clr);
	for(clr=0;clr<=6*81;clr+=81) rectangle(20+clr,85,100+clr,109);
	setcolor(clr2);settextstyle(2,0,5);
	outtextxy(38,89,"Libros");outtextxy(52,91,"_");
	outtextxy(112,89,"Revistas");outtextxy(112,91,"_");
	outtextxy(185,89,"Peridicos");outtextxy(185,91,"_");
	outtextxy(274,89,"Folletos");outtextxy(288,91,"_");
	outtextxy(348,89,"Fascculos");outtextxy(348,91,"_");
	outtextxy(444,89,"Varios");outtextxy(444,91,"_");
	outtextxy(511,89,"Acerca de");outtextxy(511,91,"_");
 }

void cejasinfynom(int clr,int clr2)
 {
	setcolor(clr);
	for(clr=0;clr<=1*81;clr+=81) rectangle(458+clr,420,538+clr,444);
	setcolor(clr2);settextstyle(2,0,5);
	outtextxy(468,424,"Opciones");outtextxy(468,426,"_");
	outtextxy(562,424,"Salir");outtextxy(562,426,"_");
 }



/*JSoft Corporation. (C) Reservados todos los derechos 2002*/